var app = angular.module("car", []);



app.directive('carList',function(){
    return{
        restrict : 'EA',
		replace : true,
		transclude : true,
		scope:{
//			id:'@',
//			fk_periodsid:'@',//期号
//			fk_ordersid:'@',//订单id(外键),
//			number:'',//购买数量
//			price:'@',//商品价格价格
//			addtime:'@',//时间
			
			content:'=', //
//			name:'@', //名称
//			pic_images:'@',//图片
//			headcount:'@', //总人数
//			numbers:'@', //商品数量numbers
//			existing:'@' //现有人数
		},
		template:'<div class="have_order">'
					+'<img src="{{content.pic_images?\'http://www.fondfell.com/superDao/\'+content.pic_images.split(\',\')[0]:\'\'}}"  />'
					+'<div>'
						+'<h4 class="no-wrap">{{content.name}}</h4>'
						+'<p>总需{{content.headcount}}人次</p>'
						+'<p>剩余<span class="surplus color_red">{{content.headcount - content.existing}}</span>人次</p>'
						+'<div>参与人次<span class="reduce" ng-click=\'jina(content)\'>-</span><input disabled  ng-model="content.number" value="{{content.number }}" class="num" type="text" /><span class="add" ng-click=\'add(content)\'>+</span></div>'
						+'<i class="delete" ng-click=\'deletes(content)\'></i>'
						+'<b class="baowei" ng-click=\'baowei(content)\'>包尾</b>'
					+'</div> '
				+'</div>',
		
	    link:function($scope,element){
		    $scope.deletes = function(item){
				car.remove(item.fk_goodsid,function(is_ok){
					//发出删除结果事件
					if(is_ok){
						eventToll.emit('deletes_ok',item);
					}else{
						eventToll.emit('deletes_ok',false);
					}
					
				});
			
			}
			
			 $scope.add = function(item){
		    	eventToll.emit('add',item);
		    }
		    $scope.jina = function(item){
		    	eventToll.emit('jina',item);
		    
		    }
		    
		    $scope.baowei = function(item){
	    		eventToll.emit('baowei',item);
		    }
			
			
	    }
	    
    }
});

app.controller('carcontroller',['$scope',function($scope){
	    $scope.carlistdata = [];
	   
	    $scope.duo_bao_bi = 0;
	    var page = 0;
	    var userid = $api.getStorage('userid');
	    if(!userid)return;
	    
	    //计算夺宝币
	    function sunsDuoBaoBi(){
	    	var zong = 0;
	    	for(var i in $scope.carlistdata){
	    		zong = zong+parseFloat($scope.carlistdata[i].price)*parseInt($scope.carlistdata[i].number);
	    	}
	    	$scope.duo_bao_bi = zong;
	    }
	 
	  	//监听apiready 加载成功
		eventToll.on('apiready',function(){
		
			 car.find(userid,page,function(data){
				$scope.carlistdata = data;
				sunsDuoBaoBi();
				$scope.$apply();
			 });
			 
			 //下拉刷新
			$api.pull(function(fn){
				page = 0;
				car.find(userid,page,function(data){
					$scope.carlistdata = data;
					sunsDuoBaoBi();
					$scope.$apply();
					fn();
				 });
				
			});
			
			$api.down(function(down){
				page++;
				car.find(userid,page,function(data){
					$scope.carlistdata = $scope.carlistdata.concat(data);
					sunsDuoBaoBi();
					$scope.$apply();
					down.is_return = true;
				 });
			
			});
			 
		});
		//监听删除商品成功
		eventToll.on('deletes_ok',function(is_ok){
			if(is_ok){
				$scope.carlistdata.splice($scope.carlistdata.indexOf(is_ok),1);
				sunsDuoBaoBi();
				$scope.$apply();
			}else{
				api.toast({
                    msg:'删除失败'
                });
			}
		});
		eventToll.on('add',function(item){
			var index = $scope.carlistdata.indexOf(item);
			var g_items =  parseInt($scope.carlistdata[index].number)+1;
			var maxNumber = parseInt($scope.carlistdata[index].headcount);
			if(g_items >= maxNumber){
				g_items = maxNumber;
			}
			$scope.carlistdata[index].number = g_items;
			sunsDuoBaoBi();
			
			
		});
		eventToll.on('jina',function(item){
			var index = $scope.carlistdata.indexOf(item);
			var g_items =  parseInt($scope.carlistdata[index].number)-1;
			var minNumber = 1;
			if(g_items <= minNumber){
				g_items = minNumber;
			}
			$scope.carlistdata[index].number = g_items;
			sunsDuoBaoBi();
		});
		
		eventToll.on('baowei',function(item){
			var index = $scope.carlistdata.indexOf(item);
			var g_items = parseInt(item.headcount) - parseInt(item.existing);
			$scope.carlistdata[index].number = g_items;
			sunsDuoBaoBi();
		});
		
		
		 $scope.submit = function(){
		 	var userid = $api.getStorage('userid');
		 	if(!userid){
		 		
		 		return api.toast({
	                 msg:'请先登录!!!'
                 });
		 	}
		 	var goodsid = [];
		 	var quantity = [];
		 	var fk_number = [];
		 	for(var i in $scope.carlistdata){
		 		goodsid.push($scope.carlistdata[i].fk_goodsid);
		 		quantity.push($scope.carlistdata[i].number);
		 		fk_number.push($scope.carlistdata[i].fk_periodsid);
		 	}
		 	
		 	if(goodsid.length == quantity.length && goodsid.length == fk_number.length){
		 		goodsid = goodsid.join(',');
		 		quantity = quantity.join(',');
		 		fk_number = fk_number.join(',');
		 	
		 		api.showProgress({
		 			title:'提交中...'
                 });
			 	api.ajax({
		             url:'http://www.fondfell.com/superDao/apis/21/dingdan/',
		             method: 'post',
		             dataType:'json',
		             timeout:'20',
		             data:{
		             	values:{
		             		goodsid:goodsid,
							quantity:quantity,
							fk_number:fk_number,
							userid:userid
		             	}
		             }
		            
	             },function(ret,err){
	             
	             	
	             	api.hideProgress();
	             	if(ret){
		             	api.confirm({
	         				title:'提示消息',
	         				msg:'提交成功，去支付?'
	                     },function(rets,err){
	                     	if(rets.buttonIndex == 2){
	                     		api.showProgress({
	                             	title:'正在查询余额信息'
	                             });
	                     		var result = ret[0];
			             		var ordernumber = result.ordernumber;
			             		var totalvaue = parseFloat(result.totalvalue);
			             		user.getMoney(userid,function(yu_e){
			             			
			             			if(totalvaue > yu_e){
			             				api.showProgress({	
                                         	title:'余额不足，使用支付宝支付'
                                         });
                                         setTimeout(function(){
                                         	api.hideProgress();
                                         },2000);
			             			}else{
			             				api.showProgress({
                                         	title:'余额充足，正在支付'
                                         });
			             				result.userid = userid;
			             				
			             				api.ajax({
			                                 url:'http://www.fondfell.com/superDao/apis/21/usermoney/',
			                                 method: 'post',
								             dataType:'json',
								             timeout:'20',
								             data:{
								             	values:result
								             }
		                                 },function(ret,err){
		                                 	api.hideProgress();
		                                 	
		                                 	if(ret && ret[0].state == 100){
		                                 		var lucknum = ret[0].lucknum;
		                                 		 notification({
													title:'购买消息',
													content:'您购买了'+$scope.carlistdata.length+'个商品,幸运号为:'+lucknum,
													extra:'001',
												});
		                                 		$scope.carlistdata = [];
		                                 		$scope.$apply();
		                                 		api.toast({
			                                         msg:'支付成功'
		                                         });
		                                         
		                                        
		                                 	}else{
		                                 		api.toast({
			                                         msg:'支付失败'
		                                         });
		                                 	}
		                                 	  
		                                 });
			             			}
			             		});
	                     	}
	                     });
			             		
	             		
	             		
	             	}else{
	             		api.toast({
	                         msg:err.msg
                         });
	             	}
	             	
	             });
	             
	             
	          }
		 
		 }
		 
		 

	  
       
}]);


function notification(option,callback,fig){
		var is_pause = false; //是否进入后台
		if(fig){
			api.addEventListener({
			    name:'pause'
			},function(ret,err){
			   is_pause = true;
			});
			api.addEventListener({
			    name:'resume'
			},function(ret,err){
			   is_pause = false;
			});
		
			if(is_pause){
				api.notification({
					vibrate:[1000,1000,1000,1000],
					light:true,
					notify:{
						title:option.title || '' ,               
					    content:option.content || '',                
					    extra:option.extra || ''  ,                
					    updateCurrent: option.updateCurrent || false    
					}
				});
			}else{
				api.notification({
					vibrate:[1000,1000,1000,1000],
					light:true,
				});
			}
			
		}else{
			api.notification({
				vibrate:[1000,1000,1000,1000],
				light:true,
				notify:{
					title:option.title || '' ,               
				    content:option.content || '',                
				    extra:option.extra || ''  ,                
				    updateCurrent: option.updateCurrent || false    
				}
			});
	
		}
	
			
	}



