var app = angular.module('myApp',[]);

apiready = function(){
    EventT.emit('apiready')		
};

app.factory('myDao',function(){

    var _selectDao = function(goodsid,fk_number,userid,callback){
        var carDao = new Dao('car');
        carDao.find.begin().select('fk_userid','='+userid).and('fk_goodsid','='+goodsid).and('fk_periodsid','='+fk_number).end(function(data){
             
             if(data.code == 200){
                var result = data.result;
                callback && callback(result);
             }
        })
            
    }
    
    var _upDate = function(goodsid,fk_number,userid,updateObject,callback){
         var carDao = new Dao('car');
         var begin = carDao.modify.begin().select('fk_userid','='+userid).and('fk_goodsid','='+goodsid).and('fk_periodsid','='+fk_number);
      
         for(var key in updateObject){
             
             var begin = begin.set(key,updateObject[key]);
         }
         
         begin.end(function(success){     
             callback&&callback(success)
         })  
    }
    
    
    
    
    var _addCart = function(cartObject,callback){
        var carDao = new Dao('car');
        
        var begin = carDao.add.begin();
        
        for(var key in cartObject){
          
            begin = begin.set(key,cartObject[key]);
        }
        
        begin.save(function(data){
            if(data.code == 200){
               api.toast({
	               msg:'加入购物车成功'
               });
               callback&&callback()
            }
        })
    }
    
    
    return {
       
        addCart:function(cartObject,callback){
            _addCart(cartObject,callback);
        },
        addNum:function(goodsid,periodsid,userid,callback){
           _selectDao(goodsid,periodsid,userid,callback);
        },
        upDate:function(goodsid,fk_number,userid,updateObject,callback){
           _upDate(goodsid,fk_number,userid,updateObject,callback)
        }
     
     }  
 })
 
 function transdate(endTime){ 
	    
	var date=new Date(); 
	date.setFullYear(endTime.substring(0,4)); 
	date.setMonth(endTime.substring(5,7)-1); 
	date.setDate(endTime.substring(8,10)); 
	date.setHours(endTime.substring(11,13)); 
	date.setMinutes(endTime.substring(14,16)); 
	date.setSeconds(endTime.substring(17,19)); 
	return Date.parse(date); 
 }
 
 var resultList=[];
 function getDataByXun(result,currentIndex,callback){
           var periodsDao = new Dao('periods');
           
           
           var goodsid = result[currentIndex].id;
         
           periodsDao.find.begin().select('fk_goodsid','='+goodsid).and('state','=0')
               .end(function(data){
                   var code = data.code;
                   if(code == 200){
                       var Presult = data.result;
                       if(Presult.length>0){
                           
                           var startTime = Presult[0].starttime;
                           
                           var sT = transdate(startTime);
	                       var date = new Date();
	                       var nT = date.getTime();
	                       
	                       if(nT>=sT){
	                           
	                           result[currentIndex].state =Presult[0].state; 
                               result[currentIndex].fk_number = Presult[0].fk_number;
                               result[currentIndex].publictime = Presult[0].publictime;
	                           resultList.push(result[currentIndex]);
	                           
	                       }
                    
                           
                          
                      
                       }
                       
                       if(currentIndex == result.length-1){
                             
                          callback&&callback(resultList);
                          return;
                       }
                       getDataByXun(result,++currentIndex,callback)
                    
                   }else{
                      api.toast({
	                      msg:'获取数据失败'
                      });
                   }
               
               })
    }

app.directive('award',['myDao',function(myDao){
    return{
        restrict : 'EA',
		replace : true,
		transclude : true,
		scope:{
		   name:'@',
		   numbers:'@',
		   headcount:'@',
		   existing:'@',
		   goodsid:'@',
		   image:'@',
		   price:'@',
		   pulbictime:'@',
		   state:'@'
		},
		template:'<div data-ripple class="goods clearfix" ng-click="openWin()">'+
				      '<div class="pic"><img src={{image}} alt="" /></div>'+
				      '<div style="margin-left:90px;">'+
					      '<h4>{{name}}</h4>'+
					      '<p>期号：{{numbers}}</p>'+
					      '<p>总需：{{headcount}}人次</p>'+
					      '<p class="progress"><b ng-style="myStyle"></b></p>'+
					      '<p>剩余：<span class="color_blue">{{existing}}</span></p>'+
					      '<button class="add" >加入清单</button>'+
					   '</div>'+
			     '</div>',
			     
	    link:function(scope,element,attrs){
	         var $element = $(element).find('.add');
	         var periodsid = scope.numbers;
	         var goodsid = scope.goodsid;
	         var price = scope.price;
	         var state = scope.state;
	         var publictime = scope.publictime;
	         
	         var $myelement = $(element); 
	         
	       
	        
	         $myelement.on('click',function(){
	             
	             $api.openWin("de_bao_win","../win_header",
			     {
	               frm_name:'goods_detail',
	               frm_url:'../html/frames0/goods_detail.html',
	               title:'奖品详情',
	               data:{
	                  goodsid:goodsid,
	                  fk_number:periodsid,
	                  state:state,
	                  publictime:publictime
	               } 
		         })
	             
	         })
	       
	         
	         $element.each(function(){
	             $(this).on('click',function(){
	                 var userid = $api.getStorage('userid');
	                 myDao.addNum(goodsid,periodsid,userid,function(result){
            
			            if(result.length > 0){
			               
			               var UObject = {};
			               var number = result[0]['number'];
			               number++;
			               UObject.number = number;
			               myDao.upDate(goodsid,periodsid,userid,UObject,function(){
			                   
			                   api.toast({
					               msg:'加入清单成功'
				               });
			               });
			            }else{
			                var addtime = getDate();
			                var cartObject = {};
			                cartObject.price = price;
					        cartObject.addtime = addtime;
					        cartObject.fk_periodsid = periodsid;
					        cartObject.fk_goodsid = goodsid;
					        cartObject.fk_userid = userid;
					        
			                
			                myDao.addCart(cartObject,function(){
			                       api.sendEvent({
				                       name:'addcartEvent'
				                   })
			                });
			            }
			        })
	                event.stopPropagation();
	             })
	         })
	         
	         
	    }
	    
    }
}])

app.factory('goodsDao',function(){
	   
     
     var _getData = function(page,type,ordertype,callback){
         var goodsDao = new Dao('goods');
         resultList=[];
         var orderArray = [];
         if(type!=1){
             var begin = goodsDao.find.begin().select("id",">0").and('fk_classify','='+type);
         }else{
             var begin = goodsDao.find.begin().select("id",">0");
         }
  
         if(ordertype == 0){
             begin = begin.orderDESC('existing');
         }else if(ordertype == 1){
             begin = begin.orderDESC('addtime');
         }else if(ordertype == 3){
             begin = begin.orderDESC('headcount');
         }
         
         begin.limit(page*=10,10).end(function(data){
             
             var code = data.code;
             
             if(code == 200){
                var result = data.result;
                
                if(result.length>0){
	                if(ordertype == 2){
	                   var progressArray = [];
	                   for(var i=0;i<result.length;i++){
	                       var headcount = result[i].headcount;
	                       var existing = result[i].existing;
	                       var progress = existing/headcount;
	                       progressArray[i] = progress;
	                   }
	                   var temp;
	                   var tempResult;
	                   for(var i=0;i<progressArray.length;i++){
	                       
	                       for(var j=i;j<progressArray.length-i;j++){
	                           if(progressArray[i] < progressArray[j]){
	                               temp = progressArray[i];
	                               progressArray[i] = progressArray[j];
	                               progressArray[j] = temp;
	                               tempResult = result[i];
	                               result[i] = result[j];
	                               result[j] = tempResult;
	                           }
	                       }
	                   }
	                }
	                getDataByXun(result,0,function(myresult){
	                    
	                    callback && callback(myresult)
	                })
                }else{
                    
                    callback && callback(result)
                }
                
             }else{
                api.toast({
	                msg:'数据拉取错误'
                });
             }
         })
     }
    
     return{
         getData:function(page,type,ordertype,callback){
            return _getData(page,type,ordertype,callback);
         }
     }
})

app.controller('goodsListController',['$scope','goodsDao',function($scope,goodsDao){
     $scope.goodlist = [];
     $scope.classifys=[];
     $scope.no_data=false;
     var page = 0;
     var type;
     var myorderby=0;
     
     EventT.on('apiready',function(){
        type = api.pageParam.data.type;
        
        //下拉刷新
        $api.pull(function(){
            resultList=[];
            page=0;
            _getData(0,type,myorderby,function(){
               api.refreshHeaderLoadDone();
            });
        })
        
        //上拉加载更多
        var myDown = $api.Down(function(){
            page++;
           
            _getData(page,type,myorderby,function(){
                 myDown.setIsReturn();
            })
        })
        
         classifyDao.findAll(function(result){
		    if(result.length>0){
		        for(var i=0;i<result.length;i++){
		           result[i]['images'] = Imageurl+result[i]['images'];
		        }
		        
		        $scope.classifys=result;
		        $scope.$apply();
		        var pop_menu = $api.dom('.pop_menu');
		        var $select_span = $api.domAll('.select_span');
		        
		        for(var i=0;i<$select_span.length;i++){
				  
			        $select_span[i].onclick=function(){
					    $api.removeCls(pop_menu, 'deploy');
				    }
				    
				}
		    }
		 })
        
        _getData(0,type,0,function(){});
     })
     
    
	
     $scope.changeBox = function(orderby){
        resultList=[];
        myorderby=orderby;
       
        _getData(0,type,orderby,function(){})
     }
    
     $scope.changeType = function(stype){
        type = stype;
        page=0;
        _getData(page,type,myorderby,function(){})
     }
     
     
     function _getData(page,type,ordertype,callback){
	     goodsDao.getData(page,type,ordertype,function(result){
	          $scope.no_data=false;
	          if(result.length>0){
	              
                  if(page == 0){
		             $scope.goodlist = [];
		          }
		          
		         
		          for(var i=0;i<result.length;i++){
		             result[i].image = Imageurl+result[i]['pic_images'].split(',')[0];
		             $scope.goodlist.push(result[i])
		          }
		         
		          $scope.$apply();
		         
		          callback&&callback()
	          }else{
	              
                  if(page==0){
	                  $scope.no_data=true;
	                  $scope.goodlist = [];
	                  $scope.$apply();
                  }else{
                      api.toast({
		                 msg:'没有更多商品'
	                  });
                  }
                  $scope.$apply();
                  callback&&callback()
	          }
	     })
     }
}])