var app = angular.module('myApp',[]);

var myEvent = new EventToll();
var goodsid = "";
apiready = function(){
	myEvent.emit('apiready');
	get_ad();
	 //拿广告
    function get_ad(){  
        
        goodsid = api.pageParam.data.goodsid;
        var goodsDao = new Dao('goods');
        var html="";
        goodsDao.find.begin().select('id','='+goodsid).end(function(data){
            if(data.code == 200){
               
               var images = data.result[0].pic_images.split(',');
                for(var i=0,l=images.length;i<l;i++){
                    
                    html+='<div  class="swiper-slide" data-hash="slide2"> <img src="'+ Imageurl+images[i]+'"></div>'
                };
                 $api.dom('.swiper-wrapper').innerHTML=html;
                
                var mySwiper = new Swiper('.swiper-container',{
				    pagination: '.swiper-pagination',
				    loop:true,
				    grabCursor: true,
				    paginationClickable: true,
				    autoplay: 5000
				});
            }
        })
        
        
        
    };
};

app.factory('Date',function(){
    var _parseMD = function(o){
		return o<10?'0'+o:o;
	}
	
	var _parseDate = function(y,m,d){
		return y+'-'+_parseMD(m)+'-'+_parseMD(d);
	}
	
	var _parseDateTime = function(y,m,d,h,i,s){
		return _parseDate(y,m,d)+ ' '+ _parseMD(h)+':'+_parseMD(i)+':'+_parseMD(s);
	}
	
	return{
	    parseDateTime:function(time){
	       var date = new Date(time);
	       var y =date.getFullYear();
		   var m =date.getMonth()+1;
		   var d =date.getDate();
		   var h =date.getHours();
		   var i =date.getMinutes()
		   var s =date.getSeconds()
		   return _parseDateTime(y,m,d,h,i,s);
	    }
	}
})


	

app.factory('Util',function(){

    
    
    var _getState = function(state){
        var mystate = "";
        
        if(state == 0){
            mystate = '准备中';
        }else if(state == 1){
            mystate = '进行中';
        }else if(state == 2){
            mystate = '已截止';
        }else{
            mystate = "已开奖"
        }
        
        return mystate;
    }
    
    
   
    
    return{
        getState:function(state){
            return _getState(state)
        }
    }
})
app.factory('myDao',['Util',function(Util){

    var _selectDao = function(goodsid,fk_number,userid,callback){
        var carDao = new Dao('car');
        carDao.find.begin().select('fk_userid','='+userid).and('fk_goodsid','='+goodsid).and('fk_periodsid','='+fk_number).end(function(data){
             
             if(data.code == 200){
                var result = data.result;
                callback && callback(result);
             }
        })
            
    }
    
    var _upDate = function(goodsid,fk_number,userid,updateObject,callback){
         var carDao = new Dao('car');
         var begin = carDao.modify.begin().select('fk_userid','='+userid).and('fk_goodsid','='+goodsid).and('fk_periodsid','='+fk_number);
      
         for(var key in updateObject){
             
             var begin = begin.set(key,updateObject[key]);
         }
         
         begin.end(function(success){     
             callback&&callback(success)
         })  
    }
    
    var _getDataRefresh = function(goodsid,callback){
         var goodsDao = new Dao('goods');
         var IntervarId;
         IntervarId = setInterval(function(){
             goodsDao.find.begin().select('id','='+goodsid).end(function(data){
                  if(data.code == 200){
                      var result = data.result;
                      if(result.length>0){
                          var headcount = parseInt(result[0]['headcount']);
                          var existing = parseInt(result[0]['existing']);
                          
                          if(existing >= headcount){
                              
                              clearInterval(IntervarId);
                              callback && callback(true,result)
                          }else{
                              callback && callback(false,result)
                          }
                      }
                  }
             })    
         },5000)
    }
   
    var _getGoodDetail = function(goodsid,callback){
        var goodsDao = new Dao('goods');
        var periodsDao = new Dao('periods');
        var detailObject = {};
        
        goodsDao.find.begin().select('id','='+goodsid).end(function(data){
            var code = data.code;
            if(code == 200){
                var result = data.result;
                detailObject['headcount'] = result[0]['headcount'];
                detailObject['existing'] = result[0]['existing'];
                detailObject['content'] = result[0]['content'];
                var residue = detailObject['headcount']-detailObject['existing'];
                
                var progress = detailObject['existing']/detailObject['headcount']*100;
                var images = result[0]['pic_images'].split(',');
                var newimages=[];
                for(var i=0;i<images.length;i++){
                    newimages[i]=Imageurl+images[i];
                	
                }
                detailObject['images'] = newimages;
                detailObject['name'] = result[0]['name'];
                var myStyleObject = {
                    width:progress+'%'
                }
                detailObject['progress'] = myStyleObject;
                detailObject['price'] = result[0]['price'];
                
                detailObject['residue'] = residue;
                callback && callback(detailObject);
                
            }
        })
    }
    
    var _addCart = function(cartObject,callback){
        var carDao = new Dao('car');
        
        var begin = carDao.add.begin();
        
        for(var key in cartObject){
          
            begin = begin.set(key,cartObject[key]);
        }
        
        begin.save(function(data){
            if(data.code == 200){
               api.toast({
	               msg:'加入购物车成功'
               });
               callback&&callback()
            }
        })
    }
    
    var _buyRecord = function(goodsid,fk_number,callback){
        var goodsorderDao = new Dao('goodsorders');
        var userDao = new Dao('user');
        
        goodsorderDao.find.begin().select('fk_goodsid','='+goodsid).and('fk_number','='+fk_number).end(function(data){
            var code = data.code;
            var userArray = {};
            var List = [];
            var total=0;
            var mylength=0;
            if(code == 200){
                var result = data.result;
                if(result.length>0){
                    for(var i=0;i<result.length;i++){
                        var userid = result[i]['fk_userid'];
                        
                        if(userArray[userid] == undefined){
                            userArray[userid] = 1;
                            mylength++;
                        }else{
                            userArray[userid]++;
                        }
                    }
                    
                  
                    
                    for(var key in userArray){
                        (function(key){
                             var newObject = {}
	                         userDao.find.begin().select('id','='+key).end(function(data){
	                              if(data.code == 200){
	                                 var result = data.result;
	                                 
	                                 if(result.length>0){
	                                     total++;
	                                     newObject.name = result[0]['name'];
	                                     newObject.time = userArray[key];
	                                     newObject.headimg = Imageurl+result[0]['pic_headimg'];
	                                     List.push(newObject);
	                                     if(total == mylength){
	                                        callback && callback(List);
	                                     }
	                                 }
	                              }
	                              
	                         })
                        })(key)
                       
                    }
                    
                }
            }
        })
        
    }
    
 
    
   
    
    return {
        getGoodDetail:function(goodsid,callback){
             _getGoodDetail(goodsid,callback)
        },
        addCart:function(cartObject,callback){
            _addCart(cartObject,callback);
        },
        addNum:function(goodsid,periodsid,userid,callback){
           _selectDao(goodsid,periodsid,userid,callback);
        },
        upDate:function(goodsid,fk_number,userid,updateObject,callback){
           _upDate(goodsid,fk_number,userid,updateObject,callback)
        },
        getDataRefresh:function(goodsid,callback){
           _getDataRefresh(goodsid,callback);
        },
        buyRecord:function(goodsid,fk_number,callback){
           _buyRecord(goodsid,fk_number,callback);
        }
    }
}])


    //抽奖
	function Chou(result,_this,callback){

		    setTimeout(function(){
				   	                          
	              var goodLuckDao = new Dao('good_luck');
	              goodLuckDao.find.begin().select('fk_number','='+result.fk_number).and('state','=2')
	              .join('user','name,pic_headimg','user.id=good_luck.fk_userid')
	              .join('goods','existing','goods.id=good_luck.fk_goodsid')
	              .join('periods','publictime','periods.fk_number=good_luck.fk_number')
	              .end(function(data){
	                  var code = data.code;
	                  if(code == 200){
	                      var myresult =  data.result;
	                      
	                      var $myparent = _this.parent(); 
	                      if(myresult.length>0){
	                         
	                          /*var html='<p>获奖者夺宝ID:<span class="name">'+myresult[0]['name']+'</span></p>'+
								'<p>参与人次:<strong class="num">'+myresult[0]['existing']+'</strong>人次</p>'+
								'<p>揭晓时间:<span class="time">'+myresult[0]['publictime']+'</span></p>';
							  
							  $myparent.html(html);*/
							  callback&&callback(myresult)
							 
						  }else{
						      api.toast({
	                              msg:'还没有抽奖'
                              });
						      var isremove = _this.attr('isremove');
                              if(!isremove){
                                  Chou(result,_this);		
                              }
						      			      
						  }
	                  }
	              })
	             
	         },5000);
         
	}

app.controller('goodController',['$scope','$http','myDao','Util','Date',function($scope,$http,myDao,Util,myDate){
    
   
    $scope.detailObject = {};
    $scope.isBuy = false;
    
    $scope.state= 0;
    var price;
    
    
    $scope.gohome = function(periodsid){
        var userid = $api.getStorage('userid');
        
         var cartObject = {};
        myDao.addNum(goodsid,periodsid,userid,function(result){
            
            if(result.length > 0){
               
               var UObject = {};
               var number = result[0]['number'];
               number++;
               UObject.number = number;
               myDao.upDate(goodsid,periodsid,userid,UObject,function(){
                   
                   api.toast({
		               msg:'加入清单成功'
	               });
               });
            }else{
                var addtime = myDate.parseDateTime();
                
                cartObject.price = price;
		        cartObject.addtime = addtime;
		        cartObject.fk_periodsid = periodsid;
		        cartObject.fk_goodsid = goodsid;
		        cartObject.fk_userid = userid;
		        
                $scope.isBuy = true;
               
                myDao.addCart(cartObject,function(){
                   $scope.isBuy = true;
                   
                   $scope.$apply()
                });
            }
            api.sendEvent({
                name:'canyu'
            })
            api.closeWin({
            });
        })
    }
    
    
    
    $scope.addCart = function(periodsid){
        
        var userid = $api.getStorage('userid');
        
        
        var cartObject = {};
        myDao.addNum(goodsid,periodsid,userid,function(result){
            
            if(result.length > 0){
               
               var UObject = {};
               var number = result[0]['number'];
               number++;
               UObject.number = number;
               myDao.upDate(goodsid,periodsid,userid,UObject,function(){
                   
                   api.toast({
		               msg:'加入清单成功'
	               });
               });
            }else{
                var addtime = myDate.parseDateTime();
                
                cartObject.price = price;
		        cartObject.addtime = addtime;
		        cartObject.fk_periodsid = periodsid;
		        cartObject.fk_goodsid = goodsid;
		        cartObject.fk_userid = userid;
		        
                $scope.isBuy = true;
               
                myDao.addCart(cartObject,function(){
                   $scope.isBuy = true;
                   
                   api.sendEvent({
                       name:'addcartEvent'
                   })
                   $scope.$apply()
                });
            }
        })
    
    
     }
    
    myEvent.on('apiready',function(){
        api.toast({
	        msg:'apiready'
        });
        goodsid = api.pageParam.data.goodsid;
        var fk_number = api.pageParam.data.fk_number;
        $scope.state = api.pageParam.data.state;
        $scope.ispart = 0;
        goodsOrders.find(fk_number,function(result){
             var len = result.length;
             if(len>0){
                $scope.ispart = 1;
             }else{
                $scope.ispart = 0;
             }
             $scope.num = len;
             $scope.$apply();
        })
        
        myDao.buyRecord(goodsid,fk_number,function(result){
            $scope.parkList = result;
           
            $scope.$apply()
        })
        
        myDao.getGoodDetail(goodsid,function(detailObject){
            price = detailObject.price;
            detailObject.fknumber = fk_number;
            var state = Util.getState($scope.state);
            detailObject.state = state;
	        $scope.detailObject = detailObject;
	        
	        $scope.openX = function(){
       
        
		        $api.openWin(
		    	"win_header48",
		    	"../win_header", 
		    	{	
		    		frm_name:"xiang_qing",
		    		frm_url:"frames0/xiangqing.html",
		    		title :"图文详情",
		    		data:{summary:detailObject.content}
		    	});
		    }
	        $scope.$apply();
	        
	     
	       
	    })
	    
	    if($scope.state == 1){
	         $scope.$apply();
	         var publictime = api.pageParam.data.publictime;
	         
	         $('.times').fnTimeCountDown(publictime,function(){
	                var result={};
	                result.fk_number = fk_number;
	                $('.times').html('获取计算结果...');
	                var _this = $(this);
					Chou(result,_this,function(result){
					    $scope.publictime = result[0]['publictime'];
					    $scope.luck_number = result[0]['luck_number'];
					    $scope.name = result[0]['name'];
					    $scope.state =2;
					    $scope.headimg = Imageurl+result[0]['pic_headimg'];
					    
					    $scope.$apply();
					});
	         })
	    }else{
		    myDao.getDataRefresh(goodsid,function(isBuyAll,result){
		       
		        $scope.detailObject.headcount = result[0]['headcount'];
		        residue = result[0]['headcount']-result[0]['existing'];
		        $scope.detailObject.residue = residue;
		       
		        var progress = result[0]['existing']/result[0]['headcount']
		        var myStyleObject = {
	                width:progress+'%'
	            }
		        $scope.detailObject['progress'] =  myStyleObject;
		        if(isBuyAll){
		            $scope.state = 1;
		           
		            var publictime = result[0]['publictime'];
		            
		            $scope.$apply();
		            //var publictime = api.pageParam.data.publictime;
	                
			        
			         
				    
		            $('.times').fnTimeCountDown(publictime,function(){     
			        })
			        
		            
		           
		        }
		        $scope.$apply();
		    })
	    }
	    
	     
    })
    
   
    

}])