var app = angular.module('myApp',[]);

app.factory('loginService',function(){

    function _checkMobile(Mobile){ 
	    if(!(/^1[3|4|5|8][0-9]\d{8}$/.test(Mobile))){ 
	        return false; 
	    }else{
	        return true;
	    } 
	} 
    
    var _Login = function(phone,password){
        if(phone == '' || password == ''){
       		api.toast({
				msg:'账号或密码不能为空'
			});
            return false;
        }else if(!_checkMobile(phone)){
       		api.toast({
				msg:'不是有效的手机号'
			});
			return false;
        }
        var userDao = new Dao('user');
        userDao.find.begin().select('phone','='+phone).and('password','='+password).end(function(data){
            if(data.code == 200){
               var result = data.result;
               if(result.length == 0){
                   api.toast({
	                   msg:'您还没有注册'
                   });
               }else{
                   var userid = result[0]['snatchid'];
                   $api.setStorage('userid',userid);
                   api.toast({
	                   msg:'登录成功'
                   });
                   api.closeWin({
                   });
               }
            }
        })
    }
    
    
    
    return{
        Login:function(phone,password){
           return _Login(phone,password);
        },
        
    }
})

app.controller('loginController',['$scope','loginService',function($scope,loginService){
    $scope.phone = "";
    $scope.password="";
    
    $scope.login = function(){
        loginService.Login($scope.phone,$scope.password);
    }
    
}])