var app = angular.module('myApp',[]);



app.directive('award',function(){
     return{
        restrict : 'EA',
		replace : true,
		transclude : true,
		scope:{
		   name:'@',
		   existing:'@',
		   numbers:'@'
		},
		template:'<div class="have_order">'+
					'<img src="../image/bens.jpg" alt="" />'+
					'<div>'+
						'<h4 class="no-wrap">{{name}}</h4>'+
						'<p>总需{{numbers}}人次</p>'+
						'<p>剩余<span class="surplus color_red">{{existing}}</span>人次</p>'+
						'<div>参与人次<span class="reduce">-</span><input class="num" type="text" value="1" /><span class="add">+</span></div>'+
						'<i class="delete" ng-click="Delete()"></i>'+
						'<b class="baowei">包尾</b>'+
					'</div>'+
					
				'</div>',
			     
	    link:function(scope,element,attrs){
	        scope.Delete = function(){
	            
	        }
	    }
	    
    }
})

app.factory('goodsordersDao',function(){
	   
		     
     var doRequest = function(start,end){
         var myDao = new Dao('goodsorders');
          
         return myDao.find.begin().select("id",">0").limit(start,end);
     }
     
     var doInsert = function(goodObject){
         
         var myDao = new Dao('goodsorders');
         var begin = myDao.add.begin();
         for(var key in goodObject){
             var mydata = goodObject[key]
             begin = begin.set(key,mydata);
         }
         begin.save(function(successStr){
             if(successStr.code == 200){
                 api.toast({
	                 msg:'订单提交成功'
                 });
             }
         })
         
     }
    
     return{
         getData:function(start,end){
            return doRequest(start,end);
         },
         insertData:function(goodObject){
            doInsert(goodObject);
         }
     }   
    
})

app.controller('orderListController',['$scope','goodsordersDao',function($scope,goodsordersDao){
    var cart = $api.getStorage('cart');
    var total = cart.length;
    
    
    function makeOrdersid(){
        var timestamp = Date.parse(new Date());
        return timestamp;
    }
    
    if(cart == undefined){
       $scope.haveorder = true;
    }else{
       $scope.haveorder = false;
              
       $scope.orders = cart;
       $scope.total = total;
       $scope.price = total;
       
       $scope.submit = function(){
          
           var ordersid = makeOrdersid();
           var userid = $api.getStorage('userid');
           var fk_goodsid="";
           var fk_number="";
           for(var i=0;i<cart.length;i++){
               var shopid = cart[i].goodsid;
               var number = cart[i].numbers;
               fk_goodsid += shopid+',';
               fk_number += number+',';
           }
           fk_goodsid =fk_goodsid.substring(0,fk_goodsid.length-1);
           fk_number = fk_number.substring(0,fk_number.length-1);
           var ordersObject = {
               fk_goodsid:fk_goodsid,
               fk_userid:userid,
               totalvalue:total,
               fk_number:fk_number,
               number:ordersid,
               state:1               
           }
           goodsordersDao.insertData(ordersObject);
       }
    }
    
    
}])