
var app = angular.module('myApp',[]);

app.directive('myRecord',function(){
    return{
        restrict : 'EA',
		replace : true,
		transclude : true,
		scope:{
		    content: '='
		},
		template:'<div class="records clearfix">'+
			        '<img  src={{content.pic_master_img}} style="display:block;width:80px" alt="" />'+
			        '<div class="record_txt" >'+
				       '<p>{{content.name}}</p>'+
				       '<p >参与期号：{{content.fk_number}}</p>'+
				       '<p>本期参与：<span>{{content.totalvalue}}</span>人次<b class="xiangqing" ng-click="openX()">查看详情</b></p>'+
			        '</div>'+
		         '</div>',
	    link:function(scope,element,attrs){
	         scope.openX = function(){
	             api.openWin({
				       name: 'win_header',
				       url: '../win_header.html',
				       pageParam:{
			               frm_name:'goods_detail',
			               frm_url:'../html/frames3/xiangqing.html',
			               title:'夺宝详情',
			               data:{
			                  fk_number:scope.content.fk_number,
			                  totalvalue:scope.content.totalvalue,
			                  name:scope.content.name,
			                  addtime:scope.content.addtime,
			                  number:scope.content.number
			               }
				       }
			       });
	         }
	    }
    }
})

app.factory('goodsDao',function(){
	   
     
     var getRecord = function(page,type,callback){
         var goodsorders = new Dao('goodsorders');
         var userid = $api.getStorage('userid');
         
         var ListArray = [];
         goodsorders.find.begin().select("fk_userid",'='+userid)
              .join('goods','pic_master_img,name','goods.id=goodsorders.fk_goodsid')
              .join('periods','state,publictime','periods.fk_number=goodsorders.fk_number')
              
              
              .limit(page*=10,10)
              .end(function(data){
                  if(data.code == 200){
                     
                      if(data.result == undefined){
                         callback&&callback(ListArray)
                         return;
                      }
                      for(var i=0;i<data.result.length;i++){
                         
                          if(data.result[i].state==0 && type==1){
                              ListArray.push(data.result[i]);
                          }else if(data.result[i].state==2 && type==2){
                              ListArray.push(data.result[i]);
                          }else if(type==0){
                              
                              ListArray.push(data.result[i])
                          }
                      }
                      callback&&callback(ListArray);
                  }else{
                      api.toast({
			             msg:'查询数据出出错咯.'
		              });
                  }
              })
         
     }
    
     return{
         getData:function(page,type,callback){
            return getRecord(page,type,callback);
         }
     }   
    
})

app.controller('recordController',['$scope','goodsDao',function($scope,goodsDao){
     $scope.recordList = [];
     $scope.isloaded = true;
     $scope.isShow = false;
     $scope.goodList=[];
    
     
     var type;
     var page= 0;
     
     EventT.on('apiready',function(type){
          
            goods.guessYouLike(function(result){
                 for(var i=0;i<result.length;i++){
                    result[i].image = Imageurl+result[i].pic_master_img;
                 }
                 $scope.goodList=result;
                
                 $scope.$apply();
            });
            type = type;
            //下拉刷新
	        $api.pull(function(){
	            
	            page = 0;
	            _getData(page,type,function(){
	               api.refreshHeaderLoadDone();
	            });
	           
	            
	        })
	        
	        
	        
	        //上拉加载更多
	        $api.down(function(){
	            var _this = this;
	            page++;
	            _getData(page,type,function(){
	                _this.is_return = true;
	            })
	        })
	       
	        _getData(0,type,function(){
	           
	        })
		    
     })
     
     
     
     $scope.gohome = function(){
         api.sendEvent({
            name:'duobao'
         })
         api.closeWin({
         });
     }
     
     $scope.openD = function(goodsid,fk_number,state,publictime){
       
      
       api.openWin({
	       name: 'win_header',
	       url: '../win_header.html',
	       pageParam:{
               frm_name:'goods_detail',
               frm_url:'../html/frames0/goods_detail.html',
               title:'奖品详情',
               data:{
                  goodsid:goodsid,
                  fk_number:fk_number,
                  state:state,
                  publictime:publictime
               } 
	       }
       });
    }
     
     function _getData(page,type,callback){
         
         goodsDao.getData(page,type,function(result){
             if(result.length>0){
                 
                 if(page == 0){
	                $scope.recordList = [];
	             }
	             for(var i=0;i<result.length;i++){
	                result[i].pic_master_img =Imageurl+result[i].pic_master_img;
	                $scope.recordList.push(result[i]);
	             }
	            
             }else{
                 if(page == 0){
                 $api.byId('nodata').style.display="block";
                 }else{
                   //$api.byId('ismore').style.display = 'block';
                 }
             }
             
             $scope.isloaded = false;
             callback && callback();
             $scope.$apply();
             
         })
	     
     }
}])