var app = angular.module('myApp',[]);

app.directive('award',function(){
    return{
        restrict : 'EA',
		replace : true,
		transclude : true,
		scope:{
		   name:'@',
		   existing:'@',
		   addtime:'@',
		   fkUserid:'@',
		   fkNumber:'@'
		},
		template:'<div>'+
			       '<div class="img"><img src="../image/test_pic.jpg" alt="" /></div>'+
			       '<h4>{{name}}</h4>'+
			       '<p>期号:{{fkNumber}}</p>'+
			       '<p>获奖者夺宝ID:<span class="name">{{fkUserid}}</span></p>'+
			       '<p>参与人次:<strong class="num">{{existing}}</strong>人次</p>'+
			       '<p>揭晓时间:<span class="time">{{addtime}}</span></p>'+
		         '</div>',
			     
	    link:function(scope,element,attrs){
	        
	    }
	    
    }
})

app.factory('luckDao',function(){
	   
		     
     var doRequest = function(start,end){
         var luckDao = new Dao('good_luck');
         
         return luckDao.find.begin().select("id",">0").limit(start,end);
     }
    
     return{
         getData:function(start,end){
            return doRequest(start,end);
         }
     }   
    
})

app.controller('winListController',['$scope','luckDao',function($scope,luckDao){
     $scope.goodlist = [];
     var start = 0;
     var pagesize = 6;
     var end = start*pagesize+pagesize;
     
     //延时加载启动
     setTimeout(function(){
        //下拉刷新
        $api.pull(function(){
            
            start = 0;
            end = start*pagesize+pagesize;
            _getData(start,end,function(){
               start++;
               api.refreshHeaderLoadDone();
            });
           
            
        })
        
        //上拉加载更多
        $api.down(function(){
            var _this = this;
            start++;
           
	        end = start*pagesize+pagesize;
            _getData(start,end,function(){
                
                _this.is_return = true;
            })
        })
     },500)
     
     _getData(start,end);
     
     function _getData(start,end,callback){
	     luckDao.getData(start,end).end(function(text){
	         
	         if(text.code == -100){
	            /*api.toast({
		            msg:'你还未开启网络'
	            });*/
	         }else if(text.code == 200){
	            
	            var result = text.result;
	           
	            if(start == 0){
	                $scope.goodlist = [];
	            }
	            
	            for(var i=0;i<result.length;i++){
	                var goodItem = result[i];
	                $scope.goodlist.push(goodItem);
	            }
	           
	            callback&&callback();
	            $scope.$apply();
	         }
	     })
     }
}])