//初始化配置参数
(function(window){
    
    window.config = {
        appcodeid:21,
        footernum:5,
        startTime:3000,
        titleArr:['夺宝','最新揭晓','清单','晒单','我的'],
        noactiveimageArray:['../image/index_images/button1.png','../image/index_images/button2.png','../image/index_images/button3.png','../image/index_images/button4.png','../image/index_images/button4.png'],
        activeimageArray:['../image/index_images/button01.png','../image/index_images/button02.png','../image/index_images/button03.png','../image/index_images/button04.png','../image/index_images/button04.png'],
        ImageArrayFiled:['noactiveimage','activeimage'], //图片数组字段
        ImageFiled:['loadingimage'], //单张图片字段
        Image64Filed:['loadingimage64'],//单张图片Base64转码字段
        TextFiled:['appcolor','appname','seller','partner','rsaPriKey','rsaPubKey','messageorders'],//文字字段
        TextArrayFiled:['footertitle'], //文字数组字段
        ImageCacheFiled:['navimage'],
        ImageCacheOneFiled:['loadingimage']
    }
})(window);


//保存初始化数据到数据表
(function(window){
    
    var AppDao = {};
    var M_JS_FILE_NAME = "data.txt";
    var M_ROOT_DIR = "fs://mode1/";
    
    AppDao.saveLocal = function(filename,data){//保存本地
        var fs = api.require('fs');
		fs.createDir({
		    path: 'fs://mode1'
		}, function(ret, err){   
		   
		   write(filename+M_JS_FILE_NAME,data,function(ret){
			   if(ret.status){
			   		
			   }
		   });
		   
		});
    }
	
	//写进文件
	function write(fileName,data,callback){
    	
        api.writeFile({
		    path: 'fs://mode1/'+fileName,
		    data: data
		},callback);
		    
	
	}
    
    //读取文件
    AppDao.Read = function(fileName,callback,errorCallback){
        
        api.readFile({
		    path: M_ROOT_DIR+fileName+M_JS_FILE_NAME
		}, function(ret, err){
		    if(ret.status){
		         var data = ret.data;
		         callback&&callback(ret.data)
		    }else{
		       errorCallback&&errorCallback()
		    }
		});
		
    }
    
    
    
    window.AppDao = AppDao;

})(window);




function toHtml(){
   
   api.removeLaunchView();
   
    //三秒后显示,启动3秒
   setTimeout(function(){
       var $body = $api.byId('ad');
        var navimage = $api.getStorage('navimage');
        var loadingimage=$api.getStorage('loadingimage');
     
       
        /*var WelcomePage = api.require('welcomePage');    
		WelcomePage.openWelcomePage({
		    isFullscreen: true,  //是否全屏(全屏不显示状态栏)  默认false
		    AnimationType: 'ZoomOutPage',  //动画类型   'Default默认', 'DepthPage深入浅出', 'Cube立方体', 'Rotate旋转','Accordion左右折叠', 'InRightUp右上角进入' , 'InRightDown右下角进入', 'ZoomOutPage淡入淡出'
		    imgs: [navimage[0],navimage[1],navimage[2]],
		    setting: {
		        isShow: true, // 是否显示页面点 默认不显示
		       
		        ImgSize: 30, // 图片size
		        ImgSpacing: 30 // 图片之间的间隔
		    }
		}, function(ret, err){        
		    if( ret ){
		        alert( JSON.stringify( ret ) );
		    }else{
		        alert( JSON.stringify( err ) );
		    }
		});*/
       try {
            api.openSlidLayout({
                type: 'left',
                leftEdge: 220,
                fixedPane: {
                    name: 'homeFixed',
                    url: 'html/homeFixed.html',
                    bounces:false
                },
                slidPane: {
                    name: 'homeSlid',
                    url: 'html/homeSlid.html'
                }
            }, function (ret) {
                
            });
       } catch (e) {
            alert(e)
       }
   },5000)
}

//首次进入app载入的js
apiready = function () {
	   toHtml();
      
       
       var firstBaseRead = true;
      
       SuperDao.init('14','YnZIlyjsnL','http://www.fondfell.com');
	   var d_user = new Dao("app_code");
	   

	   d_user.find.begin().select('id','='+config.appcodeid).end(function(text){
	        var data = text;
	        
	        if(data.code == 200){
			       var result = data.result;
			       
			       for(var i=0;i<config.TextFiled.length;i++){
			           var type = config.TextFiled[i];
			           var value = result[0][type];
			           $api.setStorage(type,value);
			       }
			       
			       for(var i=0;i<config.TextArrayFiled.length;i++){
			           var type = config.TextArrayFiled[i];
			           var valueArray = result[0][type].split(',');
			           $api.setStorage(type,valueArray);
			       }
			       
			       
			       var maincolor = result[0]['appcolor'];
			       var firstRead = $api.getStorage('firstRead');
			       isReadImg(firstRead,result);
				   isReadOneImg(result)
			       
			       var cssString = createCssFile(maincolor);
			       
			       postCssString(config.appcodeid,cssString);
			       
		         
			       
	        }else{
	             
	              api.toast({
	                  msg:'你没有网络,开启网络会有更好的app体验'
                  });
	        }
	        Init();
	   })
	   resetInit()

}

//初始默认值
function Init(){
    $api.setStorage('noactiveimage',config.noactiveimageArray);
    $api.setStorage('activeimage',config.activeimageArray);
    $api.setStorage('footertitle',config.titleArr);
    var nonum = config.noactiveimageArray.length;
    var num = config.activeimageArray.length;
    
    var $body = $api.byId('ad');
    
    var firstBaseRead = $api.getStorage('DataBaseRead');
    
    if(config.footernum != nonum || config.footernum != num){
         alert('你是猪啊，传入的图片数量与设置的底部个数不符');
    }
    
    if($api.getStorage('loadingimage')!==undefined){
        
         
         $body.src=$api.getStorage('loadingimage');
    }
    
    
    //获取多张图片，通过文件读取
    for(var i=0;i<config.ImageArrayFiled.length;i++){
         (function(i){
              var type = config.ImageArrayFiled[i];
              AppDao.Read(type,function(text){
			        var dataArray = text.split('%');
			        
			        $api.setStorage(type,dataArray);
			       
			        
			  })
         })(i)
    }
  
}

//向服务器提交css
function postCssString(appid,cssString){
       //修改服务器的css文件
       api.ajax({
           url:'http://www.fondfell.com/css/file.php',
           method:'post',
           data:{
             values:{
                keyworks:cssString, //需要存储的css字符串
                appid:appid //你的APPID
             }
           }
       },function(ret,err){
       	//coding...
       });
}





//更新一张图片
function isReadOneImg(result){
   var $body = $api.byId('ad');
   for(var i=0;i<config.ImageCacheOneFiled.length;i++){
       
       (function(i){
             var type = config.ImageCacheOneFiled[i];
             
             var image = result[0][type];
             
             if($api.getStorage(type) === undefined){
	             CacheImage(image,function(url){
	                 $api.setStorage(type,url);
	             })
             }
             
             AppDao.Read('oneCache',function(data){
                 data = data.substring(0,data.length-1);
                 var dataArray=data.split(';');
                 for(var j=0;j<dataArray.length;j++){
                     var objectkey = dataArray[j].split('=')[0];
                     var objectdata = dataArray[j].split('=')[1];
                     
                     for(var k=0;k<config.ImageCacheOneFiled.length;k++){
                           (function(k){
                               if(objectkey == config.ImageCacheOneFiled[k]){
			                       var type = config.ImageCacheOneFiled[k];
			                      
			                       if(objectdata != result[0][type]){
			                          var ImageCacheText="";
								      for(var l=0;l<config.ImageCacheOneFiled.length;l++){
								         var type = config.ImageCacheOneFiled[l];
								         var image = result[0][type];
								         ImageCacheText += type+'='+image+';';
								      }
								      
								      CacheImage(objectdata,function(url){
								          $api.setStorage(type,url);
								          $body.src=url;
								      })
			                          
						              AppDao.saveLocal('oneCache',ImageCacheText);
						              
						              
						             
			                       }
			                   }
                           })(k)
		                   
		             }
                 }
             })
             
       })(i)
       
   }
   
}



//是否读取或更新图片,多张图片
function isReadImg(firstRead,result){
    //是否更新图片
    var is_getImg = false;
    var DataObjectArray =[];
    var DataCacheArray=[];
    for(var i=0;i<config.ImageArrayFiled.length;i++){
     
       var type = config.ImageArrayFiled[i];
       var imageArray = result[0][type].split(',');
       var DataObject = {
       }
       
       DataObject[type] = imageArray;
       DataObjectArray.push(DataObject);
    }
    
    //缓存图片
    for(var i=0;i<config.ImageCacheFiled.length;i++){
       
       var type=config.ImageCacheFiled[i];
       var imageArray = result[0][type].split(',');
       var DataObject = {
       }
       
       DataObject[type] = imageArray;
       DataCacheArray.push(DataObject);
    }
    
    //单张图片缓存
    var ImageCacheText="";
    for(var i=0;i<config.ImageCacheOneFiled.length;i++){
       var type = config.ImageCacheOneFiled[i];
       var image = result[0][type];
       ImageCacheText += type+'='+image+';';
    }
    
	
    if(firstRead == undefined || firstRead == ""){
        var jsString = createJsString(DataObjectArray);
        var cacheString = createJsString(DataCacheArray);
        
        AppDao.saveLocal('oneCache',ImageCacheText);
        AppDao.saveLocal('image',jsString);
        AppDao.saveLocal('Cache',cacheString);
        saveImg(DataObjectArray,"",0);
        saveImg(DataCacheArray,"",1);
        
        $api.setStorage('firstRead',"yes");     
        
    }else{
    
        AppDao.Read('Cache',function(data){
           
           var mydata = data;
           mydata = mydata.substring(0,mydata.length-1);
           
           var dataObjectArray = [];
           dataObjectArray = mydata.split(';');
           
           for(var i=0;i<dataObjectArray.length;i++){
               
               var objectkey = dataObjectArray[i].split('=')[0];
               var objectdata = dataObjectArray[i].split('=')[1];
               
               for(var j=0;j<config.ImageCacheFiled.length;j++){
                   if(objectkey == config.ImageCacheFiled[j]){
                       var type = config.ImageCacheFiled[j];
                      
                       if(objectdata != result[0][type]){
                          
                          var jsString = createJsString(DataCacheArray);
			              AppDao.saveLocal('Cache',jsString);
			             
			              saveImg(DataCacheArray,type,1);
			              is_getImg = true;
                       }
                   }
               }
           }
        })
        
        AppDao.Read('image',function(data){
          
           var mydata = data;
           var dataObjectArray = [];
           dataObjectArray = mydata.split(';');
           
           
           
           for(var i=0;i<dataObjectArray.length;i++){
             
               var objectkey = dataObjectArray[i].split('=')[0];
               var objectdata = dataObjectArray[i].split('=')[1];
               
               for(var j=0;j<config.ImageArrayFiled.length;j++){
                   if(objectkey == config.ImageArrayFiled[j]){
                       var type = config.ImageArrayFiled[j];
                       if(objectdata != result[0][type]){
                          var jsString = createJsString(DataObjectArray);
                         
			              AppDao.saveLocal('image',jsString);
			              saveImg(DataObjectArray,type,0);
			              is_getImg = true;
                       }
                   }
               }
               
           }
          
           
        })
   }
}




//存储图片
//{{type}}要更新的字段类型
function saveImg(DataObject,type,options){
    
    if(options == 0){
        
	    for(var i=0;i<DataObject.length;i++){
	       
	          (function(i){
		          var DataObjectItem = DataObject[i];
		          var itemtype;
		          var dataArray;
		          for(var key in DataObjectItem){
		              itemtype = key;
		              dataArray = DataObjectItem[key];
		          }
		          
		          
		          if(itemtype == type || type==undefined || type==""){
		              
		              var times = 0;
		             
		              var maxlength = dataArray.length;
		              var newImage = [];
		              for(var j=0;j<maxlength;j++){
		                  (function(j){
		                      convertImgToBase64(dataArray[j],function(base64url){
		                 
				                 if(times < maxlength){     
				                      newImage[j] = base64url;
				                      
				                 }
				                 times++;
				                 if(times == maxlength){
				                      
				                      var newImageString = "";
				                     
				                      for(var k=0;k<newImage.length;k++){
				                          newImageString += newImage[k]+'%';
				                      }
				                      var newImageString = newImageString.substring(0,newImageString.length-1);
				                      $api.setStorage(itemtype,newImage);
				                      
				                      AppDao.saveLocal(itemtype,newImageString);
				                 }
				                 
				              })
		                  })(j)
		              }
		          }
	          })(i)
	       
	    }
    }else{
        for(var i=0;i<DataObject.length;i++){
	       
	          (function(i){
		          var DataObjectItem = DataObject[i];
		          var itemtype;
		          var dataArray;
		          for(var key in DataObjectItem){
		              itemtype = key;
		              dataArray = DataObjectItem[key];
		          }
		          
		        
		          
		          if(itemtype == type || type==undefined || type==""){
		              
		              var times = 0;
		             
		              var maxlength = dataArray.length;
		              var newImage = [];
		              for(var j=0;j<maxlength;j++){
		                  (function(j){
		                      CacheImage(dataArray[j],function(url){
		                 
				                 if(times < maxlength){     
				                      newImage[j] = url;
				                      
				                 }
				                 times++;
				                 if(times == maxlength){
				                      $api.setStorage(itemtype,newImage);
				                    
				                 }
				                 
				              })
		                  })(j)
		              }
		          }
	          })(i)
	       
	    }
    }
    
}

//组装css文件
function createCssFile(maincolor){
    var cssString = '.appcolor_bg{background:'+maincolor+';} .appcolor_tx{color:'+maincolor+'} ';
    return cssString;
}

//创建js文件
function createJsString(DataArray){
    var jsString = "";
    for(var i=0;i<DataArray.length;i++){
        for(var key in DataArray[i]){
           jsString += key+'='+DataArray[i][key]+';'
        }
    }
    return jsString;
}

//图片转换成base64编码
function convertImgToBase64(url,callback){
    var canvas = document.createElement('canvas');
    var $body = document.getElementsByTagName('body')[0];
    
    
    var ctx = canvas.getContext('2d');
    var img = new Image();
    img.style.display = 'none';
    img.src = url;
    
    img.onload = function(){
        canvas.width = img.width;
        canvas.height = img.height;
        ctx.drawImage(img,0,0);
        var base64url = canvas.toDataURL('image/png');
        callback.call(this,base64url);   
    }
    
    $body.appendChild(img);
}

//图片进行缓存
function CacheImage(url,callback){
    api.imageCache({
	    url: url
	}, function(ret, err){
	    var url = ret.url;
	    callback.call(this,url)
	});
}
