var footerJson = [];
var maincolor;

var foot_tx="#000";
var firstHeader = $api.byId('firstHeader');
var secHeader = $api.byId('secHeader');
var thirdHeader = $api.byId('thridHeader');
var fortheader = $api.byId('fortheader');
var fiveheader = $api.byId('fiveheader');
var firstHeaderOffset;

var main = $api.byId('main');
var mainPos = $api.offset(main);

var footer = $api.byId('footer');
var footerPos = $api.offset(footer);

var gFrameIndex;

// 随意切换按钮
function randomSwitchBtn(name, index){
    var lis = $api.domAll('.bottom_btn');
  
    var curLi = lis[index];
    
    
    for(var i=0; i<lis.length; i++){
       var thisLi = lis[i];
       var nowFooter = footerJson[i];
       
       if(thisLi === curLi){
               
           thisLi.style.backgroundImage = 'url('+footerJson[index]['active']+')';
           thisLi.style.color = maincolor;
           $api.addCls(thisLi,'activebtn');
           continue;
       }else{
           if($api.hasCls(thisLi,'activebtn')){
               thisLi.style.backgroundImage = 'url('+footerJson[i]['noactive']+')';
               thisLi.style.color = foot_tx;
               $api.removeCls(thisLi,'activebtn');
           }
       }
    }
    
    var headlis = $api.domAll('.titlebar');
    var headcurLi = headlis[index];
    
    for(var i=0;i<headlis.length;i++){
        var thisLi = headlis[i];
        
        if(thisLi ==headcurLi){
            $api.addCls(thisLi,'activebar');
            continue;
        }else{
            if($api.hasCls(thisLi, 'activebar')){
            	$api.removeCls(thisLi, 'activebar');
            }
        }
    }
}


// 隐藏所有的一级frame
function hideAllFrame(){
    
    api.setFrameAttr({
        name: 'frame0',
        hidden:true
    });
    api.setFrameAttr({
        name: 'frame1',
        hidden:true
    });
    api.setFrameAttr({
        name: 'frame2',
        hidden:true
    });
    api.setFrameAttr({
        name: 'frame3',
        hidden:true
    });
    api.setFrameAttr({
	    name: 'frame4',
	    hidden:true
    });
}

//打开frame
function openframeinstance( frame, marginTop, isBounce,reload){
    api.openFrame ({
        name: frame,
        url: './' + frame+'.html',
        rect:{
            x:0,
            y:marginTop,
            w:'auto',
            h:api.frameHeight - marginTop - footerPos.h
        },
        reload:reload,
        bounces:isBounce,
        vScrollBarEnabled:false,
        hScrollBarEnabled:false,
        delay:200
    });
}

 // ===================================
// 响应底部按钮的切换frame
// ===================================
function switchframe(type, _index){
	var userid = $api.getStorage('userid');
   if(_index == gFrameIndex  ){
   	  if((!userid && _index == 4) || (!userid && _index == 2)){
   	  	
   	  }else{
     	 return 0;
   	  }
   }else{
   	  if((!userid && _index == 4) || (!userid && _index == 2)){
   	  	
   	  }else{
     	 gFrameIndex = _index;
   	  }
   }
  
   switch(type){
       case 'first_frame':
                randomSwitchBtn('frame0', 0);
                hideAllFrame();
                openframeinstance('frame0', firstHeaderOffset.h, true,false);
                
       break;
       case 'second_frame':
            randomSwitchBtn('frame1', 1);
            hideAllFrame();
            openframeinstance('frame1', firstHeaderOffset.h, true,true);
            
        break;
        case 'third_frame':
        	if(!userid){
		    	$api.openWin(
			    	"login",
			    	"../html/win_header", 
			    	{	
			    		frm_name:"login.html",
			    		frm_url:"user/login.html",
			    		title :"登录",
		    	});
			    
        		return;
        	}
            randomSwitchBtn('frame2', 2);
            hideAllFrame();
            openframeinstance('frame2', firstHeaderOffset.h, false,true);
            
        break;
        case 'forth_frame':
            randomSwitchBtn('frame3', 3);
            hideAllFrame();
            openframeinstance('frame3', firstHeaderOffset.h, false,false);
            
        break;
        
        case 'five_frame':
        	if(!userid){
		    	$api.openWin(
			    	"login",
			    	"../html/win_header", 
			    	{	
			    		frm_name:"login.html",
			    		frm_url:"user/login.html",
			    		title :"登录",
		    	});
			    
        		return;
        	}
        
        
            randomSwitchBtn('frame4', 4);
            hideAllFrame();
            openframeinstance('frame4', firstHeaderOffset.h, false,true);
        default:
        break;
   }
}

//初始化颜色
function styleInit(){
    
    var noactiveArr =$api.getStorage('noactiveimage');
    
    var activeArr = $api.getStorage('activeimage');
    var titleArr = $api.getStorage('footertitle');
    for(var i=0;i<noactiveArr.length;i++){
       
       var newObject = {
          noactive:noactiveArr[i],
          active:activeArr[i],
          title:titleArr[i]
       };
       
       footerJson.push(newObject);
    }
    var maincolorDom = document.querySelectorAll('.main_tx');
    var mainbgDom = document.querySelectorAll('.main_bg');
    var switchDom = document.querySelectorAll('.bottom_btn');
    var tx_arr = toArray(maincolorDom);
    var bg_arr = toArray(mainbgDom);
    var sw_arr = toArray(switchDom);
   
    maincolor= $api.getStorage('appcolor');
    for(var i=0;i<tx_arr.length;i++){
        tx_arr[i].style.color = maincolor;
    }
    
    for(var i=0;i<bg_arr.length;i++){
        bg_arr[i].style.background = maincolor;
    }
    
    sw_arr.forEach(function(element,index){
        if($api.hasCls(element, 'active')){
           
            element.style.backgroundImage = 'url('+footerJson[index]['active']+')';
            element.innerText=footerJson[index]['title']
        }else{
            element.innerText=footerJson[index]['title']
            element.style.backgroundImage = 'url('+footerJson[index]['noactive']+')'
        } 
    });
    
  
    init();
}

function init(){
    $api.fixStatusBar( $api.dom('header') );
    // 设置ios7的标题栏字体变亮，全局用一个就行了
    api.setStatusBarStyle({
      style: 'dark'
    });
    
    $api.fixStatusBar(firstHeader);
    $api.fixStatusBar(secHeader); 
    $api.fixStatusBar(thirdHeader);
    $api.fixStatusBar(fortheader); 
    $api.fixStatusBar(fiveheader);
    firstHeaderOffset = $api.offset(firstHeader);
    var userid = $api.getStorage('userid');
    setInterval(function(){
        api.ajax({
		    url:'http://www.fondfell.com/superDao/apis/21/userpush/index?'+userid,
		    method:'get'
	    },function(ret,err){
	    	
	    });
    },5000)
    gettiShi();
    api.addEventListener({
	    name:'login_ok'
    },function(ret,err){
        var userid = $api.getStorage('userid');
        setInterval(function(){
            api.ajax({
			    url:'http://www.fondfell.com/superDao/apis/21/userpush/index?'+userid,
			    method:'get'
		    },function(ret,err){
		    	
		    });
        },5000)
    	
    });
    
    api.addEventListener({
	    name:'duobao'
    },function(ret,err){
    	gohome()
    });
    
    api.addEventListener({
	    name:'canyu'
    },function(ret,err){
        gettiShi()
    	goCart()
    });
    
    api.addEventListener({
	    name:'addcartEvent'
    },function(ret,err){
    	gettiShi();
    	
    });
    
    function gettiShi(){
	    var userid = $api.getStorage('userid');
	    var $tishi = $api.dom('.tishi');
	    
	    if(userid){
	       car.getCount(userid,function(count){
	           if(count>0){
	              $tishi.style.display="block";
	              $tishi.innerText = count;
	           }
	          
	       })
	    }else{
	       $tishi.style.display="none";
	    }
    }
    
    var is_close=false;
    
    function closeApp(){
        
        if(!is_close){
           api.toast({
	           msg:'再按一次退出程序'
           });
           is_close=true;
           setTimeout(function(){
               is_close = false;
           },2000)    
        }else{
           api.closeWidget({
              silent:true
           });
        }
        
    }
    
  
    api.addEventListener({
	    name:'keyback'
	}, function(ret, err){
	    closeApp();
	});
    
    
   
    gFrameIndex=0;
    
    randomSwitchBtn('first_frame',0)
    
    // 第一次进入打开 first_frame body
    api.openFrame ({
        name: 'frame0',
        url: './frame0.html',
        rect:{
        x:0,
        y:firstHeaderOffset.h,
        w:'auto',
        h:api.frameHeight-firstHeaderOffset.h -footerPos.h
        },
        bounces: true,
        opaque: false
    });

}

apiready = function(){
    styleInit();
    api.addEventListener({
	    name:'noticeclicked'
	},function(ret){
		if(ret.type == 0 ){
			switch(ret.value){
				case '001':
					openD();
					break;
			
			}
		}
	
	});
	
}

function gohome(){
    switchframe('first_frame', 0)
}

function goCart(){
    switchframe('third_frame', 2)
}

function openD(){
	     $api.openWin("de_bao_win","win_header",
	     {
	        frm_name:"win_debao",
    		frm_url:"frames3/debao.html",
    		title :"夺宝记录",
    	  
	     })
	}





function toArray(domArray){
    var newarr = [];
    for(var i=0;i<domArray.length;i++){
        newarr[i] = domArray[i];
    }
    return newarr;
}