
function LoadImage(url,selector,ex){
	this.ex = ex || 'load-ok';
	this.before_url = url;
	this.layout = document.querySelector(selector);
	this.imageObject = new Image();
	this.domList = [];
	this.index = 0;



}

LoadImage.prototype.load = function(){
	this.imageList = this.layout.querySelectorAll('img[data-src]:not(['+this.ex+'])');
	this.run();
}

LoadImage.prototype.run = function(){
	var img = this.imageList[this.index];
	var after_url = img.getAttribute('data-src');
	var get_url = this.before_url + after_url+'?date='+Date.now();
	console.log(get_url);
	this.imageObject.src = get_url;
	
	var _this = this;
	this.imageObject.onload = function(){
		img.src = get_url;
		img.setAttribute(this.ex, '');
		_this.index++;
	}
	
}