(function(window){
	var user = {};
	var table = new Dao('user');
	user.login = function(phone,password){
		table.find.begin().select('phone','='+phone).and('password','='+password).end(function(data){
			if(data.code == 200){
				var result = data.result[0];
				if(result){
					
					api.toast({
	                    msg:'登录成功!'
                    });
                    $api.setStorage('userid',result['id']);
                    api.sendEvent({
                    	name:'login_ok'
                    });
                    setTimeout(function(){
                    	api.closeWin();
                    },500);
				}else{
					api.toast({
	                    msg:'请检查账号密码是否正确'
                    });
				}
			}else{
				api.toast({
	                msg:'登录异常'
                });
			}
		});
	}
	
	user.findOne = function(userid,callback){
	    table.find.begin().select('id','='+userid).limit(0,1).end(function(data){
	        if(data.code ==200){
	            var result = data.result;
	            callback&&callback(result);
	        }
	    })
	}
	
	user.setNewPassword = function(phone,password,callback){
	    table.modify.begin().select('phone','='+phone).set('password',password).end(function(data){
	        if(data.code ==200){
	           callback&&callback(data);
	        }
	    })
	}
	
	user.upDateOne = function(userid,type,value,callback){
	   
	    table.modify.begin().select('id','='+userid).set(type,value).end(function(data){
	        if(data.code ==200){
	           callback&&callback(data);
	        }
	    })
	}
	
	user.getMoney = function(userid,callback){
		table.find.begin().select('id','='+userid).limit(0,1).end(function(data){
			if(data.code == 200){
				var result = data.result[0];
				if(result){
					var yu_e = parseFloat(result.money);
					callback&&callback(yu_e);
					
				}else{
					api.toast({
	                    msg:'数据异常!!'
                    });
				}
			}else{
				api.toast({
	                msg:'获取用户余额异常!!'
                });
			}
		});
	}
	
	user.register = function(phone,password,callback){
	    table.add.begin().set('phone',phone).set('password',password).save(function(successStr){
	        callback&&callback(successStr);
	    })
	}
	
	
	
	
	
	window.user = user;


})(window);