(function(window) {
	//SuperDao
	window.config = {
		appId : '21',
		appKey : '1bye0PT9eu'
	}
	window.SuperDao = {
		init : function(a, c, b) {
			this.appID = a;
			this.apiKey = c;
			this.globalUrl = b
		},
		keyword : {
			field_file : "file_",
			field_picture : "pic_",
			field_fk : "fk_",
			post_param : {
				tableName : "table_name",
				appID : "appid",
				where : "where",
				update : "updates"
			}
		}
	};
	function Dao(a) {
		this.tableName = a;
		this.add = {
			addValues : {},
			dao : this
		};
		this.add.begin = function() {
			this.addValues = {};
			return this
		};
		this.add.set = function(c, b) {
			if (c.indexOf(SuperDao.keyword.field_file) == 0 || c.indexOf(SuperDao.keyword.field_picture) == 0) {
				if ( b instanceof File) {
					alert("apicloud_superdao.js 不支持File对象，请传入文件路径");
					return
				}
			}
			this.addValues[c] = b;
			return this
		};
		this.add.save = function(b) {
			Dao.prototype.save(this.dao.tableName, this.addValues, b)
		};
		this.find = {
			dao : this
		};
		this.find.select = function(b, c) {
			c = convertLikeCondition2(c);
			this.selectCondition[this.selectCondition.length] = {
				field : this.dao.tableName + "." + b,
				value : c,
				type : "none"
			};
			return this
		};
		this.find.and = function(d, e, c) {
			if ( typeof (c) == "undefined") {
				c = true
			}
			e = convertLikeCondition2(e);
			if (c == false) {
				e = e.replace(/\"/g, "")
			}
			var b = c == true ? this.dao.tableName + "." : "";
			this.selectCondition[this.selectCondition.length] = {
				field : b + d,
				value : e,
				type : "and"
			};
			return this
		};
		this.find.or = function(b, c) {
			c = convertLikeCondition2(c);
			this.selectCondition[this.selectCondition.length] = {
				field : this.dao.tableName + "." + b,
				value : c,
				type : "or"
			};
			return this
		};
		this.find.limit = function(c, b) {
			this.limitCondition[0] = c;
			this.limitCondition[1] = b;
			return this
		};
		this.find.orderASC = function(b) {
			this.orderCondition[this.orderCondition.length] = {
				field : this.dao.tableName + "." + b,
				order : "ASC"
			};
			return this
		};
		this.find.orderDESC = function(b) {
			this.orderCondition[this.orderCondition.length] = {
				field : this.dao.tableName + "." + b,
				order : "DESC"
			};
			return this
		};
		this.find.filter = function(b) {
			if (this.filterResult.length > 0 && this.filterResult[0].indexOf(this.dao.tableName + ".*") >= 0) {
				this.filterResult.shift()
			}
			var c = b.split(",");
			for ( i = -1; ++i < c.length; ) {
				c[i] = c[i].replace(/^\s+|\s+$/g, "");
				if (this.filterResult.toString().indexOf(c[i]) == -1) {
					this.filterResult.push(this.dao.tableName + "." + c[i])
				}
			}
			return this
		};
		this.find.join = function(c, b, d) {
			this.jsonTableName.push(c);
			var f = "";
			if (d.indexOf("?") > 0) {
				f = "?"
			}
			if (d.indexOf("!=") > 0) {
				f = "!="
			}
			if (d.indexOf("=") > 0) {
				f = "="
			}
			if (d.indexOf(">=") > 0) {
				f = ">="
			}
			if (d.indexOf("<=") > 0) {
				f = "<="
			}
			if (d.indexOf("<") > 0) {
				f = "<"
			}
			if (d.indexOf(">") > 0) {
				f = ">"
			}
			var e = d.split(f);
			this.and(e[0], f + e[1], false);
			if (this.filterResult.length == 0) {
				this.filterResult.push(this.dao.tableName + ".*")
			}
			var g = b.split(",");
			for ( i = -1; ++i < g.length; ) {
				g[i] = g[i].replace(/^\s+|\s+$/g, "");
				if (this.filterResult.toString().indexOf(g[i]) == -1) {
					this.filterResult.push(c + "." + g[i])
				}
			}
			return this
		};
		this.find.begin = function() {
			this.orderCondition = new Array();
			this.limitCondition = new Array();
			this.selectCondition = new Array();
			this.filterResult = new Array();
			this.jsonTableName = new Array();
			return this
		};
		this.find.end = function(b) {
			Dao.prototype.find(this.dao.tableName, this.selectCondition, this.limitCondition, this.orderCondition, this.filterResult, this.jsonTableName, b)
		};
		this.remove = {
			dao : this
		};
		this.remove.select = function(b, c) {
			c = convertLikeCondition2(c);
			this.removeCondition[this.removeCondition.length] = {
				field : b,
				value : c,
				type : "none"
			};
			return this
		};
		this.remove.and = function(b, c) {
			c = convertLikeCondition2(c);
			this.removeCondition[this.removeCondition.length] = {
				field : b,
				value : c,
				type : "and"
			};
			return this
		};
		this.remove.or = function(b, c) {
			c = convertLikeCondition2(c);
			this.removeCondition[this.removeCondition.length] = {
				field : b,
				value : c,
				type : "or"
			};
			return this
		};
		this.remove.begin = function() {
			this.removeCondition = new Array();
			return this
		};
		this.remove.end = function(b) {
			Dao.prototype.remove(this.dao.tableName, this.removeCondition, b)
		};
		this.modify = {
			dao : this
		};
		this.modify.set = function(c, b) {
			if (c.indexOf(SuperDao.keyword.field_file) == 0 || c.indexOf(SuperDao.keyword.field_picture) == 0) {
				if ( b instanceof File) {
					alert("apicloud_superdao.js 不支持File对象，请传入文件路径");
					return this
				} else {
					this.modifyFiles[c] = b;
					return this
				}
			} else {
				this.modifyValues[this.modifyValues.length] = {
					field : c,
					value : b
				}
			}
			return this
		};
		this.modify.select = function(b, c) {
			c = convertLikeCondition2(c);
			this.modiryCondition[this.modiryCondition.length] = {
				field : b,
				value : c,
				type : "none"
			};
			return this
		};
		this.modify.and = function(b, c) {
			c = convertLikeCondition2(c);
			this.modiryCondition[this.modiryCondition.length] = {
				field : b,
				value : c,
				type : "and"
			};
			return this
		};
		this.modify.or = function(b, c) {
			c = convertLikeCondition2(c);
			this.modiryCondition[this.modiryCondition.length] = {
				field : b,
				value : c,
				type : "or"
			};
			return this
		};
		this.modify.begin = function() {
			this.modifyFiles = {};
			this.modifyValues = new Array();
			this.modiryCondition = new Array();
			return this
		};
		this.modify.end = function(b) {
			Dao.prototype.modify(this.dao.tableName, this.modiryCondition, this.modifyValues, this.modifyFiles, b)
		}
	}
	Dao.prototype.save = function(f, d, g) {
		var a = {};
		var b = {};
		for (var e in d) {
			if ( typeof (d[e]) != "function") {
				if (e.indexOf(SuperDao.keyword.field_file) == 0 || e.indexOf(SuperDao.keyword.field_picture) == 0) {
					a[e] = d[e]
				} else {
					b[e] = d[e]
				}
			}
		}
		b.table_name = f;
		b.appid = SuperDao.appID;
		var c = {
			values : b,
			files : a
		};
		httpPost(SuperDao.globalUrl + "/superDao/model/JSDao/add/index.php", c, function(h) {
			g(h)
		})
	};
	Dao.prototype.find = function(c, e, f, j, b, d, k) {
		var h = {};
		h.table_name = c;
		for (var g = 0; g < d.length; g++) {
			h.table_name += ", " + d[g]
		}
		h.appid = SuperDao.appID;
		h.where = JSON.stringify(e);
		h.limit = JSON.stringify(f);
		h.order = JSON.stringify(j);
		h.filter = JSON.stringify(b);
		var a = {
			values : h
		};
		httpPost(SuperDao.globalUrl + "/superDao/model/JSDao/find/index.php", a, function(l) {
			k(l)
		})
	};
	Dao.prototype.remove = function(d, a, e) {
		var b = {};
		b.table_name = d;
		b.appid = SuperDao.appID;
		b.where = JSON.stringify(a);
		var c = {
			values : b
		};
		httpPost(SuperDao.globalUrl + "/superDao/model/JSDao/remove/index.php", c, function(f) {
			e(f)
		})
	};
	Dao.prototype.modify = function(f, c, b, h, g) {
		var d = {};
		d.table_name = f;
		d.appid = SuperDao.appID;
		d.where = JSON.stringify(c);
		d.updates = JSON.stringify(b);
		var a = h;
		var e = {
			values : d,
			files : a
		};
		httpPost(SuperDao.globalUrl + "/superDao/model/JSDao/modify/index.php", e, function(j) {
			g(j)
		})
	};
	function convertLikeCondition2(d) {
		var c = /^\s*[?\uff1f]\s*/i;
		if (c.test(d)) {
			var b = d.replace(c, "");
			b = b.replace(/\\/g, "\\\\\\\\");
			b = b.replace(/\"/g, '\\"');
			b = b.replace(/%/g, "\\%");
			b = ' like "%' + b + '%"';
			return b
		}
		c = /^\s*like\s*/i;
		if (c.test(d)) {
			var b = d.replace(c, "");
			b = b.replace(/\\/, "\\\\\\\\");
			b = b.replace(/\"/g, '\\"');
			b = ' like "' + b + '"';
			return b
		}
		c = /^\s*(!=|>=|<=|=|>|<)\s*/;
		var a = c.exec(d);
		if (a != null) {
			var b = d.replace(c, "");
			if (/^(\d)*$/.test(b)) {
				return a[0] + '"' + b + '"'
			} else {
				b = b.replace(/\"/g, '\\"');
				return a[0] + '"' + b + '"'
			}
		}
		alert("条件格式错误 : " + d);
		throw "条件格式错误 : " + d
	}

	function getUrlCache(a, b) {
		api.getPrefs({
			key : a
		}, function(c, d) {
			if (c) {
				b(c.value)
			} else {
				b(null)
			}
		})
	}

	function setUrlCache(a, b) {
		api.setPrefs({
			key : a,
			value : b
		})
	}

	function httpPost(a, b, c) {
		parseUniqueStrByParam(b);
		api.ajax({
			url : a,
			method : "post",
			data : b
		}, function(e, f) {
			if (e) {
				var d = JSON.stringify(e);
				c(JSON.parse(d));
				setUrlCache(a + parseUniqueStrByParam(b), d)
			} else {
				if (f.statusCode == 500) {
					if (f.statusCode == 500) {
						f.msg = "服务器错误"
					}
					c({
						code : +f.statusCode,
						msg : f.msg
					})
				} else {
					
					getUrlCache(a + parseUniqueStrByParam(b), function(g) {
						if (f.statusCode == 0 && (g == null || g == "")) {
							f.statusCode = -1;
							c({
								code : f.statusCode,
								msg : f.msg
							})
						} else {
							if (g != null && g != "") {
								c(JSON.parse(g))
							} else {
								c({
									code : f.statusCode,
									msg : f.msg
								})
							}
						}
					})
				}
			}
		})
	}

	function parseUniqueStrByParam(d) {
		var b = "";
		var c = d.values;
		for (var a in c) {
			b += (a + c[a])
		}
		return b
	};

	window.Dao = Dao;
	SuperDao.init(config.appId, config.appKey, 'http://www.fondfell.com');
})(window);

//laytpl
(function(window) {"use strict";
	var f, b = {
		open : "{{",
		close : "}}"
	}, c = {
		exp : function(a) {
			return new RegExp(a, "g")
		},
		query : function(a, c, e) {
			var f = ["#([\\s\\S])+?","([^{#}])*?"][a || 0];
			return d((c || "") + b.open + f + b.close + (e || ""))
		},
		escape : function(a) {
			return String(a || "").replace(/&(?!#?[a-zA-Z0-9]+;)/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/'/g, "&#39;").replace(/"/g, "&quot;")
		},
		error : function(a, b) {
			var c = "Laytpl Error：";
			return "object" == typeof console && console.error(c + a + "\n" + (b || "")), c + a
		}
	}, d = c.exp, e = function(a) {
		this.tpl = a
	};
	e.pt = e.prototype, e.pt.parse = function(a, e) {
		var f = this, g = a, h = d("^" + b.open + "#", ""), i = d(b.close + "$", "");
		a = a.replace(/[\r\t\n]/g, " ").replace(d(b.open + "#"), b.open + "# ").replace(d(b.close + "}"), "} " + b.close).replace(/\\/g, "\\\\").replace(/(?="|')/g, "\\").replace(c.query(), function(a) {
			return a = a.replace(h, "").replace(i, ""), '";' + a.replace(/\\/g, "") + '; view+="'
		}).replace(c.query(1), function(a) {
			var c = '"+(';
			return a.replace(/\s/g, "") === b.open + b.close ? "" : ( a = a.replace(d(b.open + "|" + b.close), ""), /^=/.test(a) && ( a = a.replace(/^=/, ""), c = '"+_escape_('), c + a.replace(/\\/g, "") + ')+"')
		}), a = '"use strict";var view = "' + a + '";return view;';
		try {
			return f.cache = a = new Function("d, _escape_", a), a(e, c.escape)
		} catch(j) {
			return
			delete f.cache, c.error(j, g)
		}
	}, e.pt.render = function(a, b) {
		var e, d = this;
		return a ? ( e = d.cache ? d.cache(a, c.escape) : d.parse(d.tpl, a), b ? (b(e),
		void 0) : e) : c.error("no data")
	}, f = function(a) {
		return "string" != typeof a ? c.error("Template not found") : new e(a)
	}, f.config = function(a) {
		a = a || {};
		for (var c in a)
		b[c] = a[c]
	}, f.v = "1.1", "function" == typeof define ? define(function() {
		return f
	}) : "undefined" != typeof exports ? module.exports = f : window.laytpl = f
})(window);

// require module
(function(window) {
	var module = {}

	var FS_DIR = 'fs://mode/';
	var M_ROOT_DIR = null;

	var M_CSS_FILE_NAME = '_fondfell.css';

	var M_JS_FILE_NAME = '_fondfell.js';
	function addjs(scriptText) {
		var hed = document.getElementsByTagName('head')[0];
		var scripts = document.createElement('script');
		scripts.text = scriptText;
		hed.appendChild(scripts);

	}

	function addcss(cssText) {
		var hed = document.getElementsByTagName('head')[0];
		var link = document.createElement('style');
		link.textContent = cssText;
		hed.appendChild(link);

	}

	/*
	 * 插入模块
	 *
	 *
	 */
	function appendModule(mName, scriptText, callback) {
		addjs(scriptText);
		appendCss(mName);
		callback && callback(module[mName]);
	}

	function appendCss(name) {
		var http = window.XMLHttpRequest && new XMLHttpRequest();
		//本地模块地址
		var url = M_ROOT_DIR + name + M_CSS_FILE_NAME;
		http.onreadystatechange = function() {
			if (http.readyState == 3) {
				var file_text = http.responseText;
				addcss(file_text);
			}
		}
		http.open("GET", url, true);
		http.send(null);

	}

	//提示
	function toast(str) {
		api.toast({
			msg : str
		});
	}

	//初始化数据库
	function init() {
		SuperDao.init("14", "YnZIlyjsnL", "http://www.fondfell.com");
	}

	//获取数据表
	function getTable() {
		return new Dao("liaoliao_code");
	}

	//读取
	function redy(name, callback) {
		getTable().find.begin().select('name', '=' + name).end(function(text) {
			resetInit();
			//还原
			var data = text;
			if (data.code == 200) {
				var result = data.result[0];
				if (result) {
					addjs(result.mode_js);
					addcss(result.mode_css);
					saveLocal(name, result);

				}
			}
			callback && callback(data);

		});

	}

	//保存本地
	function saveLocal(name, result) {
		var fs = api.require('fs');
		fs.createDir({
			path : 'fs://mode'
		}, function(ret, err) {
			write(name + M_JS_FILE_NAME, result.mode_js, function(ret) {
				if (ret.status) {
					write(name + M_CSS_FILE_NAME, result.mode_css, function(ret2) {
						if (ret2.status) {
							$api.setStorage(name, {
								version : result.version
							});

						}
					});
				}
			});

		});

	}

	//写进文件
	function write(fileName, model, callback) {
		var fs = api.require('fs');
		fs.createFile({
			path : 'fs://mode/' + fileName,
		}, function(ret, err) {
			if (ret.status) {
				api.writeFile({
					path : 'fs://mode/' + fileName,
					data : model
				}, callback);
			}
		});

	}

	/*
	 * 检测本地模块
	 * name 模块名
	 * callback 回调   parameter file_is_true 是否跟新 true表示存在   file_text =>js文本
	 */
	function getLocalModule(name, callback) {
		var http = window.XMLHttpRequest && new XMLHttpRequest();
		//本地模块地址
		var url = M_ROOT_DIR + name + M_JS_FILE_NAME;

		var file_is_true = true;
		http.onreadystatechange = function() {
			if (http.readyState == 3) {
				var file_text = http.responseText;
				callback && callback(file_is_true, file_text);
			}
		}
		http.onerror = function(err) {
			file_is_true = false;
			callback && callback(file_is_true);
		}
		http.open("GET", url, true);
		http.send(null);

	}

	/*
	 * 检测版本号
	 * name 模块名
	 * version 本地版本号
	 * callback 回调方法     parameter is_news 是否跟新 true表示跟新
	 *
	 */
	function getVersion(name, callback) {
		getTable().find.begin().filter('version').select('name', '=' + name).end(function(text) {

			var data = text;
			var is_news = false;
			if (data.code == 200) {
				var result = data.result[0];
				if (result) {
					var versionObj = $api.getStorage(name) || {};
					var version = parseFloat(versionObj['version']);
					var v = parseFloat(result.version);

					if (version < v) {
						is_news = true;

					}
				} else {
					toast('网络模块不存在');
				}
			} else {
				toast('错误消息:' + data.msg);
			}

			callback && callback(is_news);
		});
	}

	var require = function(mName, callback) {
		if (module[mName]) {
			callback && callback(module[mName]);
			return;
		}
		M_ROOT_DIR = api.fsDir + '/mode/';
		init();

		getLocalModule(mName, function(fileBoll, fileText) {
			//本地模块存在
			if (fileBoll) {
				getVersion(mName, function(is_news) {
					//版本没有更新

					if (!is_news) {
						resetInit();
						//还原
						//插入js和css

						appendModule(mName, fileText, callback);

						//版本跟新
					} else {
						init();
						redy(mName, function(data) {
							if (data.code == -100) {
								appendModule(mName, fileText, callback);
								return;
							}

							callback && callback(module[mName]);
						});

					}

				});

				//模块不存在
			} else {
				//读取
				init();
				redy(mName, function(data) {
					if (data.code == -100) {
						toast('网络错误!!!');
						return;
					}
					callback && callback(module[mName]);

				});

			}

		});

	}
	//还原SuperDao init
	function resetInit() {
		SuperDao.init(config.appId, config.appKey, 'http://www.fondfell.com');
	}


	window.require = require;
	window.defind = function(callback) {
		callback && callback(module);

	}
	window.resetInit = resetInit;

	/*
	 * fondfell JavaScript Library
	 * Copyright (c) 2016-6-21
	 */
	function parseArguments(url, data, fnSuc, dataType, timeout) {

		if ( typeof (data) == 'function') {
			timeout = dataType;
			dataType = fnSuc;
			fnSuc = data;
			data = undefined;

		}
		if ( typeof (fnSuc) != 'function') {
			timeout = dataType;
			dataType = fnSuc;
			fnSuc = undefined;
		}
		return {
			url : url,
			data : data,
			fnSuc : fnSuc,
			dataType : dataType,
			timeout : timeout || 10
		};
	}


	$api.post = function(/*url,data,fnSuc,dataType*/) {
		var argsToJson = parseArguments.apply(null, arguments);
		var json = {};
		var fnSuc = argsToJson.fnSuc;
		argsToJson.url && (json.url = argsToJson.url);
		argsToJson.data && (json.data = argsToJson.data);
		if (argsToJson.dataType) {
			var type = argsToJson.dataType.toLowerCase();
			if (type == 'text' || type == 'json') {
				json.dataType = type;
			}
		} else {
			json.dataType = 'json';
		}
		json.timeout = argsToJson.timeout;
		json.method = 'post';
		api.ajax(json, function(ret, err) {
			fnSuc && fnSuc(ret, err);
		});
	};
	$api.get = function(/*url,fnSuc,dataType*/) {
		var argsToJson = parseArguments.apply(null, arguments);
		var json = {};
		var fnSuc = argsToJson.fnSuc;
		argsToJson.url && (json.url = argsToJson.url);
		//argsToJson.data && (json.data = argsToJson.data);
		if (argsToJson.dataType) {
			var type = argsToJson.dataType.toLowerCase();
			if (type == 'text' || type == 'json') {
				json.dataType = type;
			}
		} else {
			json.dataType = 'text';
		}
		json.timeout = argsToJson.timeout;
		json.method = 'get';
		api.ajax(json, function(ret, err) {
			fnSuc && fnSuc(ret, err);
		});
	};

})(window); 