
var phonecatApp = angular.module('myApp', []);



phonecatApp.factory('userDao',function(){
    var userDao = new Dao('user');
    var _getOne = function(userid,callback){
        
        userDao.find.begin().select('id','='+userid).end(function(data){
              if(data.code == 200){
                  var result = data.result;
                  if(result.length>0){
                      callback && callback(result);
                  }
              }
        })
    }
    
    return{
        getOne:function(userid,callback){
           _getOne(userid,callback)
        }
    }

})

phonecatApp.controller('informationController',['$scope','userDao',function($scope,userDao){
    
    EventT.on('apiready',function(){
    
        api.addEventListener({
	        name:'exit'
        },function(ret,err){
        	$scope.name="";
        	$scope.headimg='';
        	
        	$scope.$apply();
        });
        
        var userid = $api.getStorage('userid');
        
        userDao.getOne(userid,function(result){
            $scope.name = result[0]['name'];
            $scope.headimg = Imageurl+result[0]['pic_headimg'];
           
            $scope.$apply();
        })
    })
    
  
}])