(function(window){
    var goodsDao = new Dao('goods');
    var periodsDao = new Dao('periods');
    var goods={};
    
    function transdate(endTime){ 
	    
		var date=new Date(); 
		date.setFullYear(endTime.substring(0,4)); 
		date.setMonth(endTime.substring(5,7)-1); 
		date.setDate(endTime.substring(8,10)); 
		date.setHours(endTime.substring(11,13)); 
		date.setMinutes(endTime.substring(14,16)); 
		date.setSeconds(endTime.substring(17,19)); 
		return Date.parse(date); 
	}
	
	var resultList=[];
    //循环获取
    function getDataByXun(result,currentIndex,callback){
           var periodsDao = new Dao('periods');
           
           var goodsid = result[currentIndex].id;
           periodsDao.find.begin().select('fk_goodsid','='+goodsid).and('state','=0')
               .end(function(data){
                   var code = data.code;
                   if(code == 200){
                       var Presult = data.result;
                       if(Presult.length>0){
                           
                           var startTime = Presult[0].starttime;
                           
                           var sT = transdate(startTime);
	                       var date = new Date();
	                       var nT = date.getTime();
	                       
	                       if(nT>=sT){
	                           result[currentIndex].state =Presult[0].state; 
	                           result[currentIndex].publictime = Presult[0].publictime;
                               result[currentIndex].fk_number = Presult[0].fk_number;
	                           resultList.push(result[currentIndex]);      
	                       }
                       }
                       if(currentIndex == result.length-1){
                             
                          callback&&callback(resultList);
                          return;
                       }
                       
                       getDataByXun(result,++currentIndex,callback)
                    
                   }else{
                      api.toast({
	                      msg:'获取数据失败'
                      });
                   }
               
               })
    }
    
    
    goods.getAllGoods = function(type,callback,page){
        
         var goodList = [];
         resultList=[];
        
         var begin = goodsDao.find.begin().select('id','>0');
         if(type == 0){
             begin = begin.orderDESC("existing");
         }else if(type == 1){
             begin = begin.orderDESC("addtime");
         }else if(type==2){
             begin = begin.orderDESC("percentage");
         }else if(type == 3){
             begin = begin.orderDESC("headcount");
         }
         var begin = begin.limit(page*=10,10);
         begin.end(function(data){
             if(data.code){
                var result = data.result;
                if(result.length<=0){
                   callback&&callback(result)
                   return;
                }
               
                getDataByXun(result,0,function(result){
                    for(var i=0;i<result.length;i++){

	                       var goodItem = {};
	                       goodItem.fk_number = result[i]['fk_number'];
			               goodItem.state = result[i]['state'];
			               var goodsid = result[i].id;
			               goodItem.goodsid = goodsid;
			               goodItem.price = result[i]['price'];
			               goodItem.publictime = result[i]['publictime'];
			               goodItem.headcount = result[i].headcount;
	                       var progress = result[i].existing/result[i].headcount*100;
	                       var residue = result[i].headcount-result[i].existing;
	                       var images = result[i]['pic_images'].split(',');
	                       goodItem.image = Imageurl+images[0];
	                       goodItem.residue = residue;
	                       goodItem.name = result[i].name;
	                       goodItem.goodsid = result[i].id;
	                       goodItem.styleObject = {
	                           width:progress+'%'
	                       }
	                       goodItem.fk_number = result[i].fk_number;
	                       
	                       goodList.push(goodItem)
	                }
	                
	                callback &&callback(goodList);
                })
               
             }
         })
    }
    
    goods.guessYouLike = function(callback){
         var goodList=[];
         goodsDao.find.begin().select('recommend','=1').limit(0,8).end(function(data){
              var code = data.code;
              if(code ==200){
                  var result = data.result;
                  getDataByXun(result,0,function(result){
                     callback&&callback(result)
                  })
              }
         })
    }
    
    goods.getOneGoods = function(goodsid,callback){
        goodsDao.find.begin().select('id','='+goodsid).end(function(data){
             var code = data.code;
             if(code == 200){
                 var result = data.result;
                 callback&&callback(result);
             }else{
                 api.toast({
	                 msg:'获取数据失败'
                 });
             }
        })
    }
    
    window.goods = goods;
})(window)