(function(window){
    var myDao = new Dao('search');
    var goodsDao = new Dao('goods');
    var periodsDao = new Dao('periods'); 
    var searchDao={};
    
    function find(name,userid,callback){
        myDao.find.begin().select('like_name','='+name).and('fk_userid','='+userid).end(function(data){
             var code = data.code;
             if(code == 200){
                 var result = data.result;
                 if(result.length>0){
                    callback&&callback(result,true)
                 }else{
                    callback&&callback(result,false)
                 }
             }
        })
    }
    
    searchDao.findAll = function(callback){
        myDao.find.begin().select('id','>0').and('hot','=1').end(function(data){
             if(data.code == 200){
                 var result = data.result;
                 callback&&callback(result);
             }else{
                api.toast({
	                msg:'获取数据有误'
                });
             }
        })
    }
    
   
    
    searchDao.findHistory = function(userid,callback){
        myDao.find.begin().select('fk_userid','='+userid).end(function(data){
            if(data.code==200){
               var result = data.result;
               callback&&callback(result)
            }
        })
    }
    
    searchDao.clearHistory = function(userid,callback){
        myDao.remove.begin().select('fk_userid','='+userid).end(function(data){
            if(data.code == 200){
               callback&&callback();
            }
        })
    }
    
    searchDao.findGoods = function(name,callback){
        var resultList = [];
        goodsDao.find.begin().select('name','?'+name)
        .join('periods','fk_number,state','periods.fk_goodsid=goods.id')
        .end(function(data){
            if(data.code == 200){
               var result = data.result;
               for(var i=0;i<result.length;i++){
                   if(result[i].state == 0){
                      resultList.push(result[i])
                   }
               }
              
               callback&&callback(resultList)
            }
        })
    }
    
    searchDao.insert = function(name,userid){
       
        
        find(name,userid,function(result,isHave){
            if(!isHave){
               myDao.add.begin().set("like_name", name).set('fk_userid',userid).save(function(data){ 
               })
            }
        })    
    }
    
    window.searchDao = searchDao;
})(window)