(function(window){
	
	var talk = {};
	var table = new Dao('talk');
	talk.find = function(goodsid,page,callback,userid){
		table.find.begin().select('id','>0');
		if(goodsid){
			table.find.and('fk_goodsid','='+goodsid);
		
		}
		if(userid){
			table.find.and('fk_userid','='+userid);
		}
		
		table.find.join('user','pic_headimg,name as userName','user.id=talk.fk_userid')
		.join('goods','pic_images,name as goddsName','goods.id=talk.fk_goodsid')
//		.join('talk_images','image','talk_images.fk_talk_id=talk.id')
		.limit(page*=10,10);
		table.find.end(function(data){
			if(data.code == 200){
				callback&&callback(data.result);
				
			}else{
				api.toast({
	                msg:'获取数据异常'
                });
			}
		
		});
		
	}
	
	talk.findImage = function(data){
		if(data.length == 0 )return;
		eachFindImage(0,data);
	}
	
	function eachFindImage(i,data,callback){
		var table = new Dao('talk_images');
		table.find.begin().select('fk_talk_id','='+data[i].id).end(function(ret){
			if(ret.code == 200){
				var result = ret.result;
				if(result.length > 0){
					var html = '';
					
					for(var j in result){
						
						html += '<li><img  onclick=\'openBrowser('+$api.jsonToStr(result)+','+j+')\''
						 		+'src="http://www.fondfell.com/superDao/'+result[j].pic_image+'" ></li>';
					}
					
					$api.byId('talk'+data[i].id).innerHTML = html;
				}
			
			}
			i++;
			if(i < data.length ){
				eachFindImage(i,data,callback);
			}
		
		});
	}
	
	talk.add = function(imageArray,good_luck_id,fk_goodsid,userid,obj,callback){
		table.add.begin().set('content',obj.content).set('fk_goodsid',fk_goodsid).set('fk_good_luck_id',good_luck_id).set('fk_userid',userid).save(function(data){
			if(data.code == 200 && data.id){
				if(imageArray.length > 0){
					addimage(0,imageArray,data.id,callback)
				}else{
					callback&&callback();
				}
				
			}
		});
	
	
	}
	
	function addimage(i,imageArr,talk_id,callback){
		var table2 = new Dao('talk_images');
		table2.add.begin().set('fk_talk_id',talk_id).set('pic_image',imageArr[i]).save(function(data){
			if(data.code == 200){
			}else{
				api.toast({
	                msg:'图片上传出现异常'
                });
			}
			i++;
			if(i<imageArr.length){
				addimage(i,imageArr,talk_id,callback);
			}else{
				callback&&callback();
			}
		});
	
	}
	
	
	
	window.talk = talk;


})(window);