(function(){
   
   var app={};
   
   app.TransformVal = function(transformVal){
		return {
					'-webkit-transform'	: 'translate('+transformVal+'px,0)',
					'-moz-transform'	: 'translate('+transformVal+'px,0)',
					'-o-transform'		: 'translate('+transformVal+'px,0)',
					'-ms-transform'		: 'translate('+transformVal+'px,0)',
					'transform'			: 'translate('+transformVal+'px,0)'
				};
	};
   
   app.TabSlider = function(dom){
       var $this = $(dom),
           $hd = $this.find('ul.tabSlider-hd'),
           $bd = $this.find('div.tabSlider-wrap'),
           $bigbd=$this.find('.tabSlider-bd'),
           isTouchPad = (/hp-tablet/gi).test(navigator.appVersion),
           hasTouch = 'ontouchstart' in window && !isTouchPad,
           c_ev = hasTouch ? 'tap' : 'click',
           minWidth;
       
       _init = function(){
           _setStyle()
           
           $hd.children('li').on('click',_eventClick);
       }
       
       _setStyle=function(){
           minWidth = $this.width();
           var height = $(window).height()-50;
           $bd.css('height',height);
           $bigbd.css('height',height);
           $bd.find('.tabSlider-box').each(function(index){
                        $(this).css({
                           height:height
                        });
						$(this).css(app.TransformVal(index*minWidth));
					});
		   
		   $bd.css(app.TransformVal(0));
       }
       
       // hd 单击事件
	    _eventClick=function(){			
	        
			currentIndex=$(this).index();
			_switchTo();			
		},
		
		_switchTo = function(){
		   $bd.addClass('tabSlider-animate').css(app.TransformVal("-"+(minWidth*currentIndex)));
		   _nav();
		}
		
		_nav = function(){
		   $hd.children('li').eq(currentIndex).addClass('curr').siblings().removeClass('curr');
		}
		
		_init();
   }
   
   
   window.slide = app;
   

})()